;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; CABBAGE CODE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
<Cabbage>

;color macros:
#define PLANT colour(76,130,180,155) outlineColour(0,0,0,255) outlineThickness(2) presetIgnore(1)
#define BASIC colour(56, 150, 180, 255) trackerColour(56,255,182,255) outlineColour(17,37,37,155)
#define VBASIC colour("Gainsboro") trackerColour(56,255,182,255) outlineColour(17,37,37,155)
#define FTABLES tableGridColour("Silver") tableColour:0(20,20,20,245) tableBackgroundColour("Silver")
#define BUTTONS colour:0(79,79,79,105) colour:1("MediumTurquoise") colour:0("DarkSlateGrey")
#define MIDI colour:0(96,150,170,255) colour:1("Grey") value(0) latched(0) presetIgnore(1)
#define MIDIX colour:0(96,150 ,170,255) colour:1("red") value(0) latched(0) presetIgnore(1)
#define FONT fontColour("Gainsboro") presetIgnore(1)
#define RSLIDER colour(56, 150, 180, 255) trackerColour("MediumTurquoise") textColour("white") valueTextBox(1) textBoxColour("black") 

//#MAIN GUI
form channel("f1") caption("Granary") size(1303,700) pluginId("Gran") colour(76,130,180,155) style("legacy") fontColour("Gainsboro")  presetIgnore(1)
label channel("l1") bounds(5,5,50,14) text("Presets") $FONT
combobox bounds(58,3,160,25) populate("*.snaps") channelType("string") channel("cb1") ;$FONT
filebutton bounds(220,3,40,40) text("Save") populate("*.snaps") mode("named preset") channel("fb1") presetIgnore(1) 
filebutton bounds(262,3,60,40) text("Remove") populate("*.snaps") mode("remove preset") channel("fb2") presetIgnore(1) 
button bounds(1050,3,60,40) channel("record") text("Record","Stop") colour("red") fontColour("white")
combobox bounds(1115,6,55,20) channel("recch") value(2) text("mono","stereo") presetIgnore(1)
combobox bounds(1175,6,55,20) channel("bit") value(1) text("16-bit","24-bit","32-bit") presetIgnore(1)
button bounds(1240,3,60,40), channel("play") text("Play") colour("green") fontColour("white") presetIgnore(1)
keyboard bounds(115,562,1184,130) value(21) presetIgnore(1)

;PLANTS
//#Master Volume Control
image channel("i1") bounds(2,50,64,300) plant("Amp") $PLANT
{
label channel("l2") bounds(17,2,30,14) text("Amp") $FONT
vslider bounds(16,12,30,268) channel("MAmp") range(0.00, 1.5, 0.75, 1, 0.0001) $VBASIC
button bounds(13,278,27,16) text("Amp") channel("mapMamp") $MIDI
button bounds(40,278,9,16) text("") channel("mapMampX") $MIDIX
}

//#Keyboard Controller
image channel("i2") bounds(325,3,720,45) plant("Keys") $PLANT
{
label channel("l300") bounds(7,2,50,14) text("MIDI") $FONT
label channel("l3000") bounds(7,22,60,14) text("Keyboard") $FONT
label channel("l3") bounds(105,2,60,14) text("Tuning") $FONT
combobox bounds(80,22,120,17) channel("MasterScale") text("Equal Temp", "1/8 Tone", "1/6 Tone", "1/4 Tone", "1/3 Tone",  "7 Tone", "8 Tone", "9 Tone", "10 Tone", "11 Tone", "11.6 Tone", "11.8 Tone", "12.2 Tone", "12.4 Tone", "13 Tone", "14 Tone", "15 Tone")
label channel("l5") bounds(205,2,70,14) text("Tune From") $FONT
nslider bounds(220,19,50,22) channel("ScaleStart") range(20,108,60.00,1,.01) fontColour("Gainsboro")
label channel("l6") bounds(300,3,60,14) text("bend up") $FONT
label channel("l7") bounds(300,25,70,14) text("bend down") $FONT
nslider bounds(370,1,50,22) range(-24,24,2,1,.01) channel("up") fontColour("Gainsboro")
nslider bounds(370,22,50,22) range(-24,24,2,1,.01) channel("down") fontColour("Gainsboro")
button bounds(430,5,20,15) text("A") channel("mapA") $MIDI
button bounds(450,5,9,15) text("") channel("mapAX") $MIDIX
button bounds(500,5,20,15) text("D") channel("mapD") $MIDI
button bounds(520,5,9,15) text("") channel("mapDX") $MIDIX
button bounds(570,5,20,15) text("S") channel("mapS") $MIDI
button bounds(590,5,9,15) text("") channel("mapSX") $MIDIX
button bounds(640,5,20,15) text("R") channel("mapR") $MIDI
button bounds(660,5,9,15) text("") channel("mapRX") $MIDIX
rslider bounds(450,2,53,40) range(.001,10,.01,.25,.001) channel("A") $RSLIDER
rslider bounds(520,2,53,40) range(.001,10,.01,.25,.001) channel("D") $RSLIDER
rslider bounds(590,2,53,40) range(0,1,.8,1,.01) channel("S") $RSLIDER
rslider bounds(660,2,53,40) range(.001,10,.1,.25,.001) channel("R") $RSLIDER
}

//#Grain Attributes
image channel("i3") bounds(68,50,170,300) plant("Grains") $PLANT
{
label channel("l8") bounds(22,2,110,15) text("Grain Attributes") $FONT
button bounds(10,20,27,15) text("Rate") channel("maprate") $MIDI
button bounds(37,20,9,15) text("") channel("maprateX") $MIDIX
button bounds(60,20,27,15) text("Rand") channel("maprdev") $MIDI
button bounds(87,20,9,15) text("") channel("maprdevX") $MIDIX
rslider bounds(0,35,60,50) range(.25,500,50,0.5,.01) channel("rate") $RSLIDER
rslider bounds(52,35,50,50) range(0,.95,.05,.5,.01) channel("rdev") $RSLIDER
button bounds(10,90,27,15) text("Dur") channel("mapbasedur") $MIDI
button bounds(37,90,9,15) text("") channel("mapbasedurX") $MIDIX
button bounds(60,90,27,15) text("Rand") channel("mapdurdev") $MIDI
button bounds(87,90,9,15) text("") channel("mapdurdevX") $MIDIX
rslider bounds(0,105,55,50) range(.005,5,.25,.25,.001) channel("basedur") $RSLIDER
rslider bounds(52,105,50,50) range(0,.95,.1,1,.01) channel("durdev") $RSLIDER
button bounds(10,160,31,15) text("Pan") channel("mappan") $MIDI
button bounds(37,160,9,15) text("") channel("mappanX") $MIDIX
button bounds(60,160,31,15) text("Spread") channel("mapspread") $MIDI
button bounds(91,160,9,15) text("") channel("mapspreadX") $MIDIX
rslider bounds(0,175,50,50) range(0,1,.5,1,.01) channel("pan") $RSLIDER
rslider bounds(52,175,50,50) range(0,1,.25,1,.01) channel("spread") $RSLIDER
button bounds(110,45,37,15) text("F Rand") channel("mapcpsdev") $MIDI
button bounds(147,45,9,15) text("") channel("mapcpsdevX") $MIDIX
rslider bounds(104,60,55,50) range(0,24,0,.75,.01) channel("cpsdev") $RSLIDER
button bounds(110,120,37,15) text("Amp Rand") channel("mapampdev") $MIDI
button bounds(147,120,9,15) text("") channel("mapampdevX") $MIDIX
rslider bounds(104,135,50,50) range(0,.95,.1,1,.01) channel("ampdev") $RSLIDER
button bounds(10,295,67,22) channel("grainstream") text("Grain Stream") rotate(4.7124,0,0) $BUTTONS
button bounds(50,230,37,15) text("MIDI Note") channel("mapgrainstreamnote") $MIDI
button bounds(87,230,9,15) text("") channel("mapgrainstreamnoteX") $MIDIX
rslider bounds(44,245,60,50) range(20,127,60,1,.01) channel("grainstreamnote") $RSLIDER
button bounds(110,230,37,15) text("Amp") channel("mapgrainstreamamp") $MIDI
button bounds(147,230,9,15) text("") channel("mapgrainstreamampX") $MIDIX
rslider bounds(106,245,50,50) range(0,1,.75,1,.01) channel("grainstreamamp") $RSLIDER
}

//#Synthesis Models
image channel("i4") bounds(240,50,400,300) plant("Synth") $PLANT
{
combobox channel("synthSelMode") items("best score", "density") bounds(0,2,70,15)
label channel("l9") bounds(80,2,190,15) fontColour("white") text("Granular Synthesis Models") $FONT
;button bounds(330,2,60,18) text("To Buffer") channel("synthtolive") $BUTTONS
button bounds(5,22,50,18) channel("vco") text("Analog") value(1) $BUTTONS
nslider bounds(57,22,30,18) channel("vcoprev") range(1,100,25,1,1) $FONT
label channel("l111") bounds(57,42,30,10) text("weight") $FONT
combobox bounds(90,22,100,18) channel("vcosel") text("saw","square","triangle","pulse","random")
    button bounds(13,43,27,15) text("Amp") channel("mapanalogamp") latched(1) $MIDI
    button bounds(40,43,9,15) text("") channel("mapanalogampX") latched(1) $MIDIX
rslider bounds(20,58,25,25) range(0,2,.75,1,.001) channel("analogamp") $BASIC
button bounds(205,22,50,18) channel("nz") text("Noise") value(0) $BUTTONS
nslider bounds(257,22,30,18) channel("nzprev") range(1,100,25,1,1) $FONT
label channel("l112") bounds(257,42,30,10) text("weight") $FONT
combobox bounds(290,22,100,18) channel("nzsel") text("white","pink","Gaussian","random")
    button bounds(213,43,27,15) text("Amp") channel("mapnzamp") latched(1) $MIDI
    button bounds(240,43,9,15) text("") channel("mapnzampX") latched(1) $MIDIX
rslider bounds(220,58,25,25) range(0,2,.75,1,.001) channel("nzamp") $BASIC
button bounds(290,53,100,18) channel("nzfilt") text("Random Filters") value(0) $BUTTONS
combobox bounds(290,73,100,18) channel("nzfiltsel") text("bandpass","lowpass","highpass","random")
    button bounds(213,95,32,15) text("Freq 1") channel("mapnzfiltF1") latched(1) $MIDI
    button bounds(245,95,9,15) text("") channel("mapnzfiltF1X") latched(1) $MIDIX
    rslider bounds(203,110,60,45) range(20,20000,200,.5,1) channel("nzfiltF1") $RSLIDER
    button bounds(258,95,32,15) text("Freq 2") channel("mapnzfiltF2") latched(1) $MIDI
    button bounds(290,95,9,15) text("") channel("mapnzfiltF2X") latched(1) $MIDIX
    rslider bounds(248,110,60,45) range(20,20000,800,.5,1) channel("nzfiltF2") $RSLIDER
    button bounds(308,95,27,15) text("Q 1") channel("mapnzfiltQ1") latched(1) $MIDI
    button bounds(335,95,9,15) text("") channel("mapnzfiltQ1X") latched(1) $MIDIX   
    rslider bounds(298,110,60,45) range(.5,100,2,1,.1) channel("nzfiltQ1") $RSLIDER 
    button bounds(353,95,27,15) text("Q 2") channel("mapnzfiltQ2") latched(1) $MIDI
    button bounds(380,95,9,15) text("") channel("mapnzfiltQ2X") latched(1) $MIDIX
    rslider bounds(343,110,60,45) range(.5,100,5,1,.1) channel("nzfiltQ2") $RSLIDER
    
button bounds(5,91,50,18) channel("wave") text("Waves") value(0) $BUTTONS
nslider bounds(57,91,30,18) channel("waveprev") range(1,100,25,1,1) $FONT
label channel("l113") bounds(57,111,30,10) text("weight") $FONT
combobox bounds(90,91,100,18) channel("wavesel") text("saw", "square", "triangle", "pulse","sine", "rand basics","harmonic 1","harmonic 2", "harmonic 3", "harmonic 4", "harmonic 5", "harmonic 6", "harmonic 7", "harmonic 8","harmonic 9", "harmonic 10", "harmonic 11", "harmonic 12", "harmonic 13", "harmonic 14", "harmonic 15", "rand 5 harm.", "rand 10 harm.", "rand 15 harm.", "piano", "guitar","cello","violin","rand strings","trombone","horn","trumpet","rand brass","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","rand woodwinds","rand")
    button bounds(13,112,27,15) text("Amp") channel("mapwaveamp") latched(1) $MIDI
    button bounds(40,112,9,15) text("") channel("mapwaveampX") latched(1) $MIDIX
rslider bounds(18,127,25,25) range(0,2,.75,1,.001) channel("waveamp") $BASIC

button bounds(5,160,50,18) channel("fm") text("FM") value(0) $BUTTONS
nslider bounds(57,160,30,18) channel("fmprev") range(1,100,25,1,1) $FONT
label channel("l114") bounds(57,180,30,10) text("weight") $FONT
    button bounds(13,182,27,15) text("Amp") channel("mapfmamp") latched(1) $MIDI
    button bounds(40,182,9,15) text("") channel("mapfmampX") latched(1) $MIDIX
rslider bounds(18,197,25,25) range(0,2,.75,1,.001) channel("fmamp") $BASIC
label channel("l10") bounds(55,197,40,14) fontColour(255, 255, 255, 255) text("mod") $FONT
label channel("l11") bounds(55,211,40,14) fontColour(255, 255, 255, 255) text("ratio") $FONT
button bounds(100,160,27,15) text("Base") channel("maprat1") $MIDI
button bounds(127,160,9,15) text("") channel("maprat1X") $MIDIX
button bounds(140,160,27,15) text("Target") channel("maprat2") $MIDI
button bounds(167,160,9,15) text("") channel("maprat2X") $MIDIX
button bounds(190,165,20,15) text("A") channel("mapfmA") $MIDI
button bounds(210,165,9,15) text("") channel("mapfmAX") $MIDIX
button bounds(230,165,20,15) text("D") channel("mapfmD") $MIDI
button bounds(250,165,9,15) text("") channel("mapfmDX") $MIDIX
button bounds(270,165,20,15) text("S") channel("mapfmS") $MIDI
button bounds(290,165,9,15) text("") channel("mapfmSX") $MIDIX
button bounds(310,165,20,15) text("R") channel("mapfmR") $MIDI
button bounds(330,165,9,15) text("") channel("mapfmRX") $MIDIX
button bounds(348,160,27,15) text("Rand") channel("mapmodrand") $MIDI
button bounds(375,160,9,15) text("") channel("mapmodrandX") $MIDIX
rslider bounds(90,175,55,50) range(.25,10,1.51,.5,.001) channel("rat1") $RSLIDER
rslider bounds(130,175,55,50) range(.25,10,1.56,.5,.001) channel("rat2") $RSLIDER
rslider bounds(175,180,60,45) range(.001,10,.01,.25,.001) channel("fmA") $RSLIDER
rslider bounds(215,180,60,45) range(.001,10,.01,.25,.001) channel("fmD") $RSLIDER
rslider bounds(255,180,60,45) range(0,1,.8,1,.01) channel("fmS") $RSLIDER
rslider bounds(295,180,60,45) range(.001,10,.1,.25,.001) channel("fmR") $RSLIDER
rslider bounds(340,175,55,50) range(0, 0.95, 0.01, 1, 0.001) channel("modrand") $RSLIDER
button bounds(100,230,27,15) text("Base") channel("mapind1") $MIDI
button bounds(127,230,9,15) text("") channel("mapind1X") $MIDIX
button bounds(140,230,27,15) text("Target") channel("mapind2") $MIDI
button bounds(167,230,9,15) text("") channel("mapind2X") $MIDIX
button bounds(190,235,20,15) text("A") channel("mapindA") $MIDI
button bounds(210,235,9,15) text("") channel("mapindAX") $MIDIX
button bounds(230,235,20,15) text("D") channel("mapindD") $MIDI
button bounds(250,235,9,15) text("") channel("mapindDX") $MIDIX
button bounds(270,235,20,15) text("S") channel("mapindS") $MIDI
button bounds(290,235,9,15) text("") channel("mapindSX") $MIDIX
button bounds(310,235,20,15) text("R") channel("mapindR") $MIDI
button bounds(330,235,9,15) text("") channel("mapindRX") $MIDIX
button bounds(348,230,27,15) text("Rand") channel("mapindexrand") $MIDI
button bounds(375,230,9,15) text("") channel("mapindexrandX") $MIDIX
label channel("l12") bounds(55,267,50,14) fontColour(255, 255, 255, 255) text("mod") $FONT
label channel("l13") bounds(55,281,50,14) fontColour(255, 255, 255, 255) text("index") $FONT
rslider bounds(90,245,55,50) range(1,99,2,1,.01) channel("ind1") $RSLIDER
rslider bounds(130,245,55,50) range(1,99,3,1,.01) channel("ind2") $RSLIDER
rslider bounds(175,250,60,45) range(.001,10,.01,.25,.001) channel("indA") $RSLIDER
rslider bounds(215,250,60,45) range(.001,10,.01,.25,.001) channel("indD") $RSLIDER
rslider bounds(255,250,60,45) range(0,1,.8,1,.01) channel("indS") $RSLIDER
rslider bounds(295,250,60,45) range(.001,10,.1,.25,.001) channel("indR") $RSLIDER
rslider bounds(340,245,55,50) range(0, 0.95, 0.01, 1, 0.01) channel("indexrand") $RSLIDER
}


image channel("i5") bounds(642,50,285,300) plant("Granulator") channel("livegraincontainer00") $PLANT
{
//#Live Granulation GUI

    label channel("l14") bounds(0,2,285,16) text("Live Granulation") $FONT
    
    button text("Live Grains") channel(liveGrainState) bounds(10,18,65,18) $BUTTONS 
    button channel("livefreeze") bounds(80,18,40,18) text("Freeze") $BUTTONS
    label channel("l140") bounds(145,21,35,12) text("Inputs") $FONT
    combobox channel("livepanMode") items("mono in", "stereo in") bounds(190,21,65,14) align("left") value(2)

    button bounds(16,40,27,15) text("Amp") channel("mapliveGrainAmp") $MIDI
    button bounds(43,40,9,15) text("") channel("mapliveGrainAmpx") $MIDIX
    rslider bounds(20,55,25,25) range(0,2,.75,1,0.001) channel("liveGrainAmp") $BASIC
    
    button  bounds(90,40,37,15) text("Mic/Line") channel("mapintolive") $MIDI
    button  bounds(127,40,8,15) text("") channel("mapintolivex") $MIDIX
    rslider channel("intolive") bounds(85,55,55,40) range(0,2,1,1,0.001) $RSLIDER
    
    button  bounds(140,40,27,15) text("Synth") channel("mapsynthtolive") $MIDI
    button  bounds(167,40,8,15) text("") channel("mapsynthtolivex") $MIDIX
    rslider channel("synthtolive") bounds(130,55,55,40) range(0,2,0,1,0.001) $RSLIDER
    
    button  bounds(185,40,27,15) text("SF") channel("mapsftolive") $MIDI
    button  bounds(212,40,8,15) text("")  channel("mapsftolivex") $MIDIX
    rslider channel("sftolive") bounds(175,55,55,40) range(0,2,0,1,0.001) $RSLIDER
    
    button  bounds(230,40,27,15) text("FX") channel("mapouttolive") $MIDI
    button  bounds(257,40,8,15) text("") channel("mapouttolivex") $MIDIX
    rslider channel("outtolive") bounds(220,55,55,40) range(0,2,0,1,0.001) $RSLIDER
    
    label channel("l141") bounds(5,85,50,12) text("Grains") $FONT
    
    button  bounds(16,99,27,15) text("Rate") channel("mapliverate") $MIDI
    button  bounds(43,99,8,15) text("") channel("mapliveratex") $MIDIX
    rslider channel("liverate") range(0.25, 500 , 30, 0.5, 0.01) bounds(5,114,60,45)  $RSLIDER
    
    button  bounds(55,107,15,15) text("R") channel("mapliverateRandom") $MIDI
    button  bounds(71,107,8,15) text("") channel("mapliverateRandomx") $MIDIX
    rslider channel("liverateRandom") range(0, 1 , 0, 1, 0.01) bounds(55,122,20,20) $BASIC

    button  bounds(113,99,27,15) text("Pitch") channel("maplivetranspose") $MIDI
    button  bounds(140,99,8,15) text("") channel("maplivetransposex") $MIDIX
    rslider channel("livetranspose") range(-24, 24, 0, 1, 0.01) bounds(103,114,60,45) $RSLIDER
    
    button  bounds(152,107,15,15) text("R") channel("maplivetransposeRandom") $MIDI 
    button  bounds(168,107,8,15) text("") channel("maplivetransposeRandomx") $MIDIX
    rslider channel("livetransposeRandom") range(0, 12 , 0, 1, 0.01) bounds(152,122,20,20) $BASIC

    button  bounds(211,99,27,15) text("Pan") channel("maplivepanCenter") $MIDI 
    button  bounds(238,99,8,15) text("") channel("maplivepanCenterx") $MIDIX
    rslider channel("livepanCenter") range(0, 1, 0.5, 1, 0.01) bounds(200,114,60,45) $RSLIDER
    
    button  bounds(250,107,15,15) text("R") channel("maplivepanRandom") $MIDI 
    button  bounds(266,107,8,15) text("") channel("maplivepanRandomx") $MIDIX
    rslider channel("livepanRandom") range(0, 1 , 0.25, 1, 0.01) bounds(250,122,20,20) $BASIC
        
    button  bounds(63,154,27,15) text("Dur") channel("maplivegrainSize") $MIDI
    button  bounds(90,154,8,15) text("")channel("maplivegrainSizex") $MIDIX
    rslider channel("livegrainSize") range(.005,5,.1,0.5,.001) bounds(52,169,60,45) $RSLIDER ;old range(50,500,100,.5,1) was in ms
    
    button  bounds(102,162,15,15) text("R") channel("maplivegrainSizeRandom") $MIDI
    button  bounds(118,162,8,15) text("") channel("maplivegrainSizeRandomx") $MIDIX
    rslider channel("livegrainSizeRandom") range(0, 1 , 0, 1, 0.01) bounds(102,177,20,20)  $BASIC
    
    button  bounds(161,154,27,15) text("Env") channel("maplivewindowPos") $MIDI 
    button  bounds(188,154,8,15) text("") channel("maplivewindowPosx") $MIDIX
    rslider channel("livewindowPos") range(0, 1, 0, 1, 0.01) bounds(150,169,60,45) $RSLIDER
    
    button  bounds(200,162,15,15) text("R") channel("maplivewindowPosRandom") $MIDI 
    button  bounds(216,162,8,15) text("") channel("maplivewindowPosRandomx") $MIDIX  
    rslider channel("livewindowPosRandom") range(0, 1 , 0, 1, 0.01) bounds(200,177,20,20) $BASIC

    label channel("l123") bounds(5,205,50,12) text("Delay") $FONT

    button  bounds(10,220,37,15) text("Max Del") channel("mapliveloopSize")  $MIDI 
    button  bounds(47,220,8,15) text("") channel("mapliveloopSizex")  $MIDIX
    hslider channel("liveloopSize") range(.5,20,10,1,.01) bounds(60,220,210,15) valueTextBox(1) textBoxColour("black") textColour("Gainsboro") $VBASIC

    button  bounds(15,238,27,15) text("Delay") channel("maplivedelay") $MIDI
    button  bounds(42,238,8,15) text("") channel("maplivedelayx") $MIDIX
    rslider channel("livedelay") range(.0001, 1 , 1,0.5, 0.0001) bounds(5,253,60,45) $RSLIDER
    
    button  bounds(55,246,15,15) text("R") channel("maplivedelayRandom") $MIDI
    button  bounds(71,246,8,15) text("") channel("maplivedelayRandomx") $MIDIX
    rslider channel("livedelayRandom") range(0, 1 , 1, 1, 0.01) bounds(55,261,20,20) $BASIC    

    button  bounds(81,238,27,15) text("FB") channel("maplivefeedback") $MIDI 
    button  bounds(108,238,8,15) text("") channel("maplivefeedbackx") $MIDIX
    rslider channel("livefeedback") range(0,0.99, 0, 1, 0.01) bounds(70,253,60,44) $RSLIDER
    
    button  bounds(120,246,15,15) text("R") channel("maplivefeedbackRand") $MIDI 
    button  bounds(136,246,8,15) text("") channel("maplivefeedbackRandx") $MIDIX
    rslider channel("livefeedbackRand") range(0,1, 0, 1, 0.01) bounds(120,261,20,20) $BASIC

    button  bounds(146,238,27,15) text("FB Del") channel("maplivefeedbackdelay") $MIDI 
    button  bounds(173,238,8,15) text("") channel("maplivefeedbackdelayx") $MIDIX
    rslider channel("livefeedbackdelay") range(.001,1,.05,0.5,.001) bounds(135,253,60,45) $RSLIDER ;a percentage of the Max Del Size
        
    button  bounds(185,246,15,15) text("R") channel("maplivefeedbackdelayRand") $MIDI 
    button  bounds(201,246,8,15) text("") channel("maplivefeedbackdelayRandx") $MIDIX
    rslider channel("livefeedbackdelayRand") range(0,1, 0, 1, 0.01) bounds(185,261,20,20) $BASIC
    
    button  bounds(211,238,33,15) text("Overdub") channel("mapliveoverdub") $MIDI 
    button  bounds(244,238,8,15) channel("mapliveoverdubx") text("") $MIDIX
    rslider channel("liveoverdub") range(0,1,0, 1, 0.01) bounds(200,253,60,45) $RSLIDER
    
    }

//#SF Granulation
image channel("i27") bounds(929,50,370,300) plant("Granulator") channel("sfgrainimage0") $PLANT
{
label channel("l27") bounds(0,2,370,16) text("Soundfile Granulation") $FONT
image bounds(5,15,365,280) colour(0,0,0,0) channel("sfgrainimage1"){

    filebutton bounds(0,10,50,18) channel("openFile") text("Load SF") $BUTTONS
    button bounds(53,10,35,18) channel("sfplay") text("Play") $BUTTONS
    button bounds(91,10,35,18) channel("sfloop") text("Loop") $BUTTONS
    button bounds(129,12,27,15) text("Amp") channel("mapsfamp") $MIDI
    button bounds(156,12,9,15) text("") channel("mapsfampX") $MIDIX
    rslider bounds(167,5,25,30) channel("sfamp") range(0, 5, .75, 0.75, 0.001) $BASIC
    button bounds(195,10,50,18) channel("scrubon") text("Scrub") value(0) $BUTTONS
    button bounds(250,10,60,18) text("Keyboard") channel("sfkey") $BUTTONS
    
    soundfiler bounds(0,35,310,135) channel("beg","len") colour(0,255,255,255) fontColour("MediumTurquoise") identChannel("SFfiler") 
    
    hslider bounds(0,173,310,25) channel("scrub") range(0,1,0,1,.00001) valueTextBox(1) textBoxColour("black") textColour("Gainsboro") $VBASIC
    button bounds(130,193,30,15) text("Scrub") channel("mapscrub") $MIDI
    button bounds(160,193,9,15) text("") channel("mapscrubX") $MIDIX
    
    rslider bounds(310,220,55,50) channel("scrubTr") range(0,24,.05,1,0.01) $RSLIDER
    button bounds(310,205,42,15) text("Pitch Rand") channel("mapscrubTr") $MIDI
    button bounds(352,205,9,15) text("") channel("mapscrubTrX") $MIDIX
    
    button bounds(318,10,30,15) text("Pitch") channel("mapscrubT") $MIDI
    button bounds(348,10,9,15) text("") channel("mapscrubTX") $MIDIX
    vslider bounds(305,23,60,170) channel("scrubT") range(-36,36,0,1,.01) valueTextBox(1) textBoxColour("black") textColour("Gainsboro") $VBASIC
    
    rslider bounds(0,220,55,50) channel("scrubr") range(0,.95,.05,1,0.001) $RSLIDER
    button bounds(0,205,42,15) text("Scrub Rand") channel("mapscrubr") $MIDI
    button bounds(40,205,9,15) text("") channel("mapscrubrX") $MIDIX

    image bounds(60,230,250,50) colour(0,0,0,0) channel("sfgrainimage2"){
    
        button bounds(0,0,70,18) channel("targeton") text("Target") value(0) latched(1) $BUTTONS

        label channel("l15") bounds(0,30,60,12) text("Time") align("left") $FONT
        nslider bounds(30,26,40,20) range(.1,600,5,.5,.01) channel("targetdur") fontColour("Gainsboro")
    
        label channel("l102") bounds(75,4,60,12) text("Scrub") align("left")  $FONT
        nslider bounds(105,0,40,20) range(0,1,0,1,.0001) channel("targetL") fontColour("Gainsboro")

        label channel("l103") bounds(147,4,80,12) text("Scrub Rand")  align("left") $FONT
        nslider bounds(210,0,40,20) range(0,.95,0,1,.01) channel("targetLr") fontColour("Gainsboro")

        label channel("l100") bounds(75,30,60,12) align("left")text("Pitch") $FONT
        nslider bounds(105,26,40,20) range(-24,24,0,1,.01) channel("targetT") fontColour("Gainsboro")
        
        label channel("l101") bounds(147,30,60,12) text("Pitch Rand") $FONT  
        nslider bounds(210,26,40,20) range(-24,24,0,1,.01) channel("targetTr") fontColour("Gainsboro")
        
    }
    }
    
}
}
;FX plants:
//#Vibrato (LFO Modulation, controller 1)
image channel("i13") bounds(2,532,110,160) plant("Vib") $PLANT
{
label channel("l31") bounds(25,2,50,14) text("Vibrato") $FONT
button bounds(53,25,27,15) text("Rand") channel("mapvibrand") $MIDI
button bounds(80,25,9,15) text("") channel("mapvibrandX") $MIDIX
rslider bounds(20,20,25,25) channel("vibrand") range(0, .99, 0.05, .5, 0.001) $BASIC

button bounds(18,145,27,15) text("Rate") channel("mapvibcps") $MIDI
button bounds(45,145,9,15) text("") channel("mapvibcpsX") $MIDIX
vslider bounds(21,75,30,75) channel("vibcps") range(0, 1, 0, .5, .01) $VBASIC

button bounds(63,145,27,15) text("Depth") channel("mapvibdepth") $MIDI
button bounds(90,145,9,15) text("") channel("mapvibdepthX") $MIDIX
vslider bounds(63,75,30,75) channel("vibdepth") range(0, 1, .5, .5, 0.01) $VBASIC

label bounds(10,45,65,12) text("set max:") fontColour(255,255,255,255)
nslider bounds(12,60,43,19) channel("vibcpsmax") range(0,2500,10,1,.01) fontColour("Gainsboro")
nslider bounds(56,60,43,19) channel("vibdepthmax") range(0,48,.75,1,.01) fontColour("Gainsboro")
}

//#Random Note Generator
image channel("i11") bounds(2,450,200,82) plant("Random Note Generator") $PLANT
{
button bounds(5,3,80,18) channel("RNGon") text("Random Base F", "Random Note Generator") value(0) $BUTTONS
combobox bounds(90,3,100,16) channel("RNGmicro") text("Equal Temp", "Microtonal", "1/4 Tone", "1/8 Tone", "Whole Tone", "Minor 3rds", "Major 3rds", "4ths", "Tritones", "5ths", "10 Tone", "13 Tone", "15 Tone", "7 Tone", "8 Tone")
button bounds(140,45,50,16) channel("RNGgliss") text("S&H", "Gliss") value(0) $BUTTONS

button bounds(5,25,27,15) text("Rate") channel("mapRNGrate") $MIDI
button bounds(32,25,9,15) text("") channel("mapRNGrateX") $MIDIX
rslider bounds(5,45,35,35) channel("RNGrate") range(0.01, 100, 3.3, .5, 0.01) $BASIC

button bounds(50,25,27,15) text("R Dev") channel("mapRNGraterand") $MIDI
button bounds(77,25,9,15) text("") channel("mapRNGraterandX") $MIDIX
rslider bounds(50,45,35,35) channel("RNGraterand") range(0, .95, 0, 1, 0.01) $BASIC

button bounds(100,25,27,15) text("F Dev") channel("mapRNGdev") $MIDI
button bounds(127,25,9,15) text("") channel("mapRNGdevX") $MIDIX
rslider bounds(100,45,35,35) channel("RNGdev") range(0, 60, 6, 1, 0.01) $BASIC
}

//#Distortion
image channel("i12") bounds(205,350,55,182) plant("Distort") $PLANT
{
button bounds(5,3,45,18) channel("diston") text("Distort", "Distort") value(0) $BUTTONS
button bounds(8,30,27,15) text("Dist") channel("mapdist") $MIDI
button bounds(35,30,9,15) text("") channel("mapdistX") $MIDIX
rslider bounds(10,45,35,35) channel("distA") range(0, 1, 0, 1, 0.01) $BASIC 
button bounds(8,80,30,15) text("Shape") channel("mapdist2") $MIDI
button bounds(38,80,9,15) text("") channel("mapdist2X") $MIDIX
rslider bounds(10,95,35,35) channel("distB") range(0, .999, 0, 1, 0.001) $BASIC 
button bounds(8,130,27,15) text("Fold") channel("mapdist3") $MIDI
button bounds(35,130,9,15) text("") channel("mapdist3X") $MIDIX
rslider bounds(8,145,35,35) channel("distC") range(1, 25, 1, .5, 0.001) $BASIC 
}

//#Latched Lowpass 
image channel("i6") bounds(262,350,158,182) plant("LatchedLP") $PLANT
{
button bounds(5,3,75,18) channel("LLPon") text("Dynamic Filter") value(0) $BUTTONS
button bounds(82,3,22,18) channel("LLPlp") text("LP","LP") value(1) $BUTTONS
button bounds(106,3,22,18) channel("LLPbp") text("BP","BP") value(0) $BUTTONS
button bounds(130,3,22,18) channel("LLPhp") text("HP","HP") value(0) $BUTTONS
combobox bounds(83,22,70,16) channel("LLPcfset") text("MIDI in","Static")
label channel("l19") bounds(82,40,70,10) text("(pitch in MIDI)") $FONT

label channel("l17") bounds(2,30,35,14) text("Freq") $FONT
label channel("l20") bounds(2,44,35,10) text("Offset") visible(1) $FONT identChannel("offsetlabel") 
rslider bounds(2,54,35,35) channel("offset") range(-36,36,12,1,.01) visible(1) $BASIC identChannel("LLPoffset") 
label channel("l21") bounds(4,44,25,10) text("Base") visible(0) $FONT identChannel("baselabel")
rslider bounds(2,54,35,35) channel("base") range(20,120,84,1,.01) visible(0) $BASIC identChannel("LLPbase") 
label channel("l22") bounds(35,44,35,10) text("Target") $FONT
rslider bounds(35,54,35,35) channel("target") range(-36,36,18,1,.01) $BASIC
label channel("l18") bounds(68,75,80,10) text("A      D      S      R") $FONT
rslider bounds(60,85,25,25) range(.001,10,.05,.25,.001) channel("cfA") $BASIC
rslider bounds(83,85,25,25) range(.001,10,.05,.25,.001) channel("cfD") $BASIC
rslider bounds(106,85,25,25) range(.001,1,.6,1,.01) channel("cfS") $BASIC
rslider bounds(129,85,25,25) range(.001,10,.1,.25,.001) channel("cfR") $BASIC

label channel("l23") bounds(2,100,15,14) text("Q") $FONT
label channel("l24") bounds(4,114,25,10) text("Base") $FONT
rslider bounds(2,124,35,35) channel("LLPQbase") range(.5, 25, 5, 1, 0.01) $BASIC
label channel("l25") bounds(35,114,35,10) text("Target") $FONT
rslider bounds(35,124,35,35) channel("LLPQtarget") range(.5, 25, 10, 1, 0.01) $BASIC
label channel("l188") bounds(68,145,80,10) text("A      D      S      R") $FONT
rslider bounds(60,155,25,25) range(.001,10,.05,.25,.001) channel("QA") $BASIC
rslider bounds(83,155,25,25) range(.001,10,.05,.25,.001) channel("QD") $BASIC
rslider bounds(106,155,25,25) range(.001,1,.6,1,.01) channel("QS") $BASIC
rslider bounds(129,155,25,25) range(.001,10,.1,.25,.001) channel("QR") $BASIC
}

//#LP Filter
image channel("i14") bounds(422,350,85,182) plant("LP") $PLANT
{
button bounds(20,3,45,18) channel("LPon") text("Lowpass", "Lowpass") value(0) $BUTTONS
combobox bounds(13,25,60,14) channel("LPsel") text("-6 dB","-12 dB","-18 dB","-24 dB")
label channel("l33") bounds(43,40,35,12) text("LFO") $FONT
label channel("l333") bounds(45,51,35,8) text("rate") $FONT
label channel("l332") bounds(45,79,35,8) text("depth") $FONT
label channel("l322") bounds(8,107,30,8) text("rand") $FONT
label channel("l323") bounds(45,117,35,8) text("rate") $FONT
label channel("l331") bounds(45,145,35,8) text("depth") $FONT
button bounds(5,45,27,15) text("Cutoff") channel("mapLPcps") $MIDI
button bounds(32,45,9,15) text("") channel("mapLPcpsX") $MIDIX
rslider bounds(7,60,35,35) channel("LPcps") range(2, 14, 11, 1, .001) $BASIC ;pitch expressed in oct
button bounds(5,130,27,15) text("Res") channel("mapLPres") $MIDI
button bounds(32,130,9,15) text("") channel("mapLPresX") $MIDIX
rslider bounds(7,145,35,35) channel("LPres") range(0.01, .99, 0.1, 1, 0.01) $BASIC

rslider bounds(51,58,25,25) channel("LPcfr") range(0,75,0,.5,.01) $BASIC
rslider bounds(51,86,25,25) channel("LPcfd") range(0,2.5,0,.5,.01) $BASIC
rslider bounds(31,100,25,25) channel("LPrand") range(0,.95,0,1,.01) $BASIC
rslider bounds(51,124,25,25) channel("LPresr") range(0,75,0,.5,.01) $BASIC
rslider bounds(51,152,25,25) channel("LPresd") range(0,2.5,0,.5,.01) $BASIC
}

//#Parallel Filters (selectable)
image channel("i15") bounds(509,350,218,182) plant("parallel") $PLANT
{
button bounds(5,3,45,18) channel("paron") text("Filters") value(0) $BUTTONS
combobox bounds(53,3,90,16) channel("vpresets") text("Voice Formants","Soprano ah","Soprano eh","Soprano ih","Soprano oh","Soprano uh","Alto ah","Alto eh","Alto ih","Alto oh","Alto uh","Tenor ah","Tenor eh","Tenor ih","Tenor oh","Tenor uh","Bass ah","Bass eh","Bass ih","Bass oh","Bass uh", )
label channel("l34") bounds(150,5,25,10) text("port") $FONT
rslider bounds(175,0,25,25) channel("fport") range(0,5,.1,.25,0.01) $BASIC 
label channel("l35") bounds(5,25,30,12) text("Filter") $FONT
label channel("l36") bounds(38,25,35,12) text("Cutoff") $FONT
label channel("l37") bounds(75,37,70,10) text("rate          rand") $FONT
label channel("l377") bounds(86,28,45,10) text("depth") $FONT
label channel("l38") bounds(144,25,35,12) text("Res") $FONT
label channel("l39") bounds(177,25,35,12) text("Amp") $FONT
combobox bounds(3,44,35,14) channel("parsel1") text("LP","BP","HP","off") value(1) identChannel("ps1") 
combobox bounds(3,79,35,14) channel("parsel2") text("LP","BP","HP","off") value(2)
combobox bounds(3,114,35,14) channel("parsel3") text("LP","BP","HP","off") value(2)
combobox bounds(3,149,35,14) channel("parsel4") text("LP","BP","HP","off") value(3)
rslider bounds(38,35,35,35) channel("parF1") range(2,14,8,1,0.001) $BASIC  ;expressing pitch in oct and resonance needs to be between .5-25
rslider bounds(38,70,35,35) channel("parF2") range(2,14,9,1,0.001) $BASIC 
rslider bounds(38,105,35,35) channel("parF3") range(2,14,10,1,0.001) $BASIC 
rslider bounds(38,140,35,35) channel("parF4") range(2,14,11,1,0.001) $BASIC 
rslider bounds(73,47,25,25) channel("parcfr1") range(0,75,0,.5,.01) $BASIC
rslider bounds(73,82,25,25) channel("parcfr2") range(0,75,0,.5,.01) $BASIC
rslider bounds(73,117,25,25) channel("parcfr3") range(0,75,0,.5,.01) $BASIC
rslider bounds(73,152,25,25) channel("parcfr4") range(0,75,0,.5,.01) $BASIC
rslider bounds(96,38,25,25) channel("parcfd1") range(0,2.5,0,.5,.001) $BASIC ;depth calculated in oct as well
rslider bounds(96,73,25,25) channel("parcfd2") range(0,2.5,0,.5,.001) $BASIC
rslider bounds(96,108,25,25) channel("parcfd3") range(0,2.5,0,.5,.001) $BASIC
rslider bounds(96,143,25,25) channel("parcfd4") range(0,2.5,0,.5,.001) $BASIC
rslider bounds(119,47,25,25) channel("parcfrnd1") range(0,.95,0,1,.01) $BASIC
rslider bounds(119,82,25,25) channel("parcfrnd2") range(0,.95,0,1,.01) $BASIC
rslider bounds(119,117,25,25) channel("parcfrnd3") range(0,.95,0,1,.01) $BASIC
rslider bounds(119,152,25,25) channel("parcfrnd4") range(0,.95,0,1,.01) $BASIC
rslider bounds(145,35,35,35) channel("parres1") range(.5,25,1,1,0.01) $BASIC
rslider bounds(145,70,35,35) channel("parres2") range(.5,25,1,1,0.01) $BASIC 
rslider bounds(145,105,35,35) channel("parres3") range(.5,25,1,1,0.01) $BASIC 
rslider bounds(145,140,35,35) channel("parres4") range(.5,25,1,1,0.01) $BASIC
rslider bounds(179,35,35,35) channel("paramp1") range(0,1.5,1,1,0.001) $BASIC 
rslider bounds(179,70,35,35) channel("paramp2") range(0,1.5,1,1,0.001) $BASIC 
rslider bounds(179,105,35,35) channel("paramp3") range(0,1.5,1,1,0.001) $BASIC
rslider bounds(179,140,35,35) channel("paramp4") range(0,1.5,1,1,0.001) $BASIC
}

//#phaser
image channel("i16") bounds(729,350,55,182) plant("Phaser") $PLANT
{
button bounds(5,3,45,18) channel("phson") text("Phaser", "Phaser") $BUTTONS
button bounds(10,30,27,15) text("Speed") channel("mapphscps") $MIDI
button bounds(37,30,9,15) text("") channel("mapphscpsX") $MIDIX
rslider bounds(10,45,35,35) channel("phscps") range(0.01, 100, .4, 0.25, 0.01) $BASIC
button bounds(10,80,27,15) text("FB") channel("mapphsFB") $MIDI
button bounds(37,80,9,15) text("") channel("mapphsFBX") $MIDIX
rslider bounds(10,95,35,35) channel("phsFB") range(0, 1, 0.5, 1, 0.01) $BASIC
button bounds(10,130,27,15) text("Q") channel("mapphsQ") $MIDI
button bounds(37,130,9,15) text("") channel("mapphsQX") $MIDIX
rslider bounds(10,145,35,35) channel("phsQ") range(0.01, 100, 1, .25, 0.01) $BASIC
}

//#flanger
image channel("i17") bounds(786,350,55,182) plant("Flanger") $PLANT
{
button bounds(5,3,45,18) channel("flon") text("Flanger", "Flanger") $BUTTONS
button bounds(10,30,27,15) text("Speed") channel("mapflcps") $MIDI
button bounds(37,30,9,15) text("") channel("mapflcpsX") $MIDIX
rslider bounds(10,45,35,35) channel("flcps") range(0.01, 100, .05, 0.25, 0.01) $BASIC
button bounds(10,80,27,15) text("FB") channel("mapflFB") $MIDI
button bounds(37,80,9,15) text("") channel("mapflFBX") $MIDIX
rslider bounds(10,95,35,35) channel("flFB") range(0, .99, 0.5, 1, 0.01) $BASIC
}

//#Transposer/Harmonizer
image channel("i18") bounds(843,350,255,182) plant("Transposer") $PLANT
{
button bounds(4,3,58,18) channel("ton") text("Transposer", "Transposer") $BUTTONS
button bounds(87,4,27,15) text("Mix") channel("mapharmmix") $MIDI
button bounds(114,4,9,15) text("") channel("mapharmmixX") $MIDIX
rslider bounds(62,0,25,25) channel("harmmix") range(0, 1, .5, 1, 0.01) $BASIC
combobox bounds(128,3,80,16) channel("Tpresets") text("Fat","Fatter","Warble","5ths","4ths","M3rds","Mi3rds","Cluster 1","Cluster 2","Whole Tones","Stacked 5ths","Stacked 4ths","Stacked M3rds","Stacked Mi3rds","8ves","Big 5ths","Major","Minor","V7","M7","M9","Mi7","Sus","V7sus","V7+9","V9","V7+9B")
label channel("l40") bounds(206,5,25,8) text("port") $FONT
rslider bounds(228,0,25,25) channel("Tport") range(0,5,.02,.25,0.01) $BASIC 

button bounds(8,29,38,15) channel("harmon1") text("Off", "On") value(1) $BUTTONS
button bounds(8,45,29,15) text("Coarse") channel("mapharmon1C") $MIDI
button bounds(37,45,9,15) text("") channel("mapharmon1CX") $MIDIX
rslider bounds(1, 60, 55, 50) channel("harmon1C") range(-24, 24, 0, 1, 1) $RSLIDER
button bounds(10,115,27,15) text("Fine") channel("mapharmon1F") $MIDI
button bounds(37,115,9,15) text("") channel("mapharmon1FX") $MIDIX
rslider bounds(1, 130, 55, 50) channel("harmon1F") range(-1, 1, .14, 1, 0.01) $RSLIDER
button bounds(48,29,38,15) channel("harmon2") text("Off", "On") value(1) $BUTTONS
button bounds(48,45,29,15) text("Coarse") channel("mapharmon2C") $MIDI
button bounds(77,45,9,15) text("") channel("mapharmon2CX") $MIDIX
rslider bounds(41, 60, 55, 50) channel("harmon2C") range(-24, 24, 0, 1, 1) $RSLIDER
button bounds(48,115,27,15) text("Fine") channel("mapharmon2F") $MIDI
button bounds(75,115,9,15) text("") channel("mapharmon2FX") $MIDIX
rslider bounds(41, 130, 55, 50) channel("harmon2F") range(-1, 1, 0-.16, 1, 0.01) $RSLIDER
button bounds(88,29,38,15) channel("harmon3") text("Off", "On") value(1) $BUTTONS
button bounds(88,45,29,15) text("Coarse") channel("mapharmon3C") $MIDI
button bounds(117,45,9,15) text("") channel("mapharmon3CX") $MIDIX
rslider bounds(81, 60, 55, 50) channel("harmon3C") range(-24, 24, 0, 1, 1) $RSLIDER
button bounds(88,115,27,15) text("Fine") channel("mapharmon3F") $MIDI
button bounds(115,115,9,15) text("") channel("mapharmon3FX") $MIDIX
rslider bounds(81, 130, 55, 50) channel("harmon3F") range(-1, 1, .09, 1, 0.01) $RSLIDER
button bounds(128,29,38,15) channel("harmon4") text("Off", "On") value(1) $BUTTONS
button bounds(128,45,29,15) text("Coarse") channel("mapharmon4C") $MIDI
button bounds(157,45,9,15) text("") channel("mapharmon4CX") $MIDIX
rslider bounds(121, 60, 55, 50) channel("harmon4C") range(-24, 24, 0, 1, 1) $RSLIDER
button bounds(128,115,27,15) text("Fine") channel("mapharmon4F") $MIDI
button bounds(155,115,9,15) text("") channel("mapharmon4FX") $MIDIX
rslider bounds(121, 130, 55, 50) channel("harmon4F") range(-1, 1, 0-.12, 1, 0.01) $RSLIDER
button bounds(168,29,38,15) channel("harmon5") text("Off", "On") value(1) $BUTTONS
button bounds(168,45,29,15) text("Coarse") channel("mapharmon5C") $MIDI
button bounds(197,45,9,15) text("") channel("mapharmon5CX") $MIDIX
rslider bounds(161, 60, 55, 50) channel("harmon5C") range(-24, 24, 0, 1, 1) $RSLIDER
button bounds(168,115,27,15) text("Fine") channel("mapharmon5F") $MIDI
button bounds(195,115,9,15) text("") channel("mapharmon5FX") $MIDIX
rslider bounds(161, 130, 55, 50) channel("harmon5F") range(-1, 1, 0.11, 1, 0.01) $RSLIDER
button bounds(208,29,38,15) channel("harmon6") text("Off", "On") value(1) $BUTTONS
button bounds(208,45,29,15) text("Coarse") channel("mapharmon6C") $MIDI
button bounds(237,45,9,15) text("") channel("mapharmon6CX") $MIDIX
rslider bounds(201, 60, 55, 50) channel("harmon6C") range(-24, 24, 0, 1, 1) $RSLIDER
button bounds(208,115,27,15) text("Fine") channel("mapharmon6F") $MIDI
button bounds(235,115,9,15) text("") channel("mapharmon6FX") $MIDIX
rslider bounds(201, 130, 55, 50) channel("harmon6F") range(-1, 1, -.05, 1, 0.01) $RSLIDER
}

//#Chorus
image channel("i19") bounds(1100,350,90,182) plant("Chorus") $PLANT
{
button bounds(15,3,45,18) channel("chon") text("Chorus", "Chorus") $BUTTONS
button bounds(8,30,27,15) text("Mix") channel("mapchmix") $MIDI
button bounds(35,30,9,15) text("") channel("mapchmixX") $MIDIX
button bounds(48,30,27,15) text("Rate") channel("mapchcps") $MIDI
button bounds(75,30,9,15) text("") channel("mapchcpsX") $MIDIX
rslider bounds(8,45,35,35) channel("chmix") range(0, 1, .5, 1, 0.01) $BASIC 
rslider bounds(48,45,35,35) channel("chcps") range(.01, 25, .5, .5, 0.001) $BASIC 
button bounds(8,80,27,15) text("FB") channel("mapchFB") $MIDI
button bounds(35,80,9,15) text("") channel("mapchFBX") $MIDIX
button bounds(48,80,27,15) text("Depth") channel("mapchdepth") $MIDI
button bounds(75,80,9,15) text("") channel("mapchdepthX") $MIDIX
rslider bounds(8,95,35,35) channel("chFB") range(0, .999, .7, 1, 0.001) $BASIC 
rslider bounds(48,95,35,35) channel("chdepth") range(.1, 50, 1.5, .5, 0.01) $BASIC 
button bounds(8,130,27,15) text("Delay") channel("mapchdel") $MIDI
button bounds(35,130,9,15) text("") channel("mapchdelX") $MIDIX
button bounds(48,130,27,15) text("Rand") channel("mapchrand") $MIDI
button bounds(75,130,9,15) text("") channel("mapchrandX") $MIDIX
rslider bounds(8,145,35,35) channel("chdel") range(.1, 50, 15, 1, 0.01) $BASIC 
rslider bounds(48,145,35,35) channel("chrand") range(0, .9, .1, .5, 0.001) $BASIC 
}

//#delay
image channel("i20") bounds(1192,350,50,182) plant("Delay") $PLANT
{
button bounds(6,3,40,18) channel("delon") text("Delay", "Delay") $BUTTONS
button bounds(8,30,27,15) text("Time") channel("mapdeltime") $MIDI
button bounds(35,30,9,15) text("") channel("mapdeltimeX") $MIDIX
rslider bounds(0,45,53,50) channel("deltime") range(0.001, 4.99, .08, 0.25, 0.001) $RSLIDER
button bounds(8,100,27,15) text("FB") channel("mapdelFB") $MIDI
button bounds(35,100,9,15) text("") channel("mapdelFBX") $MIDIX
rslider bounds(0,115,53,50) channel("delFB") range(0, .99, .35, 1, 0.01) $RSLIDER
}

//#reverbsc
image channel("i21") bounds(1244,350,55,182) plant("Reverb") $PLANT
{
button bounds(5,3,45,18) channel("revon") text("Reverb", "Reverb") $BUTTONS
button bounds(8,30,30,15) text("Mix") channel("maprevmix") $MIDI
button bounds(38,30,9,15) text("") channel("maprevmixX") $MIDIX
rslider bounds(10,45,35,35) channel("revmix") range(0,1, .35, 1, 0.01) $BASIC
button bounds(8,80,30,15) text("Decay") channel("maprevFB") $MIDI
button bounds(38,80,9,15) text("") channel("maprevFBX") $MIDIX
rslider bounds(10,95,35,35) channel("revFB") range(0.01,0.999, .75, 1.75, 0.001) $BASIC
button bounds(8,130,30,15) text("LP") channel("maprevLP") $MIDI
button bounds(38,130,9,15) text("") channel("maprevLPX") $MIDIX
rslider bounds(10,145,35,35) channel("revLP") range(200, 20000, 12500, .5, 10) $BASIC
}

//#ribbon controller
image channel("i22") bounds(115,533,1184,26) plant("ribbon") $PLANT
{
button bounds(5,5,40,15) text("Ribbon") channel("maprib") $MIDI
button bounds(45,5,9,15) text("") channel("mapribX") $MIDIX
hslider bounds(56,2,1079,20) channel("ribbon") range(-36, 36, 0, 1, .0001) valueTextBox(1) textBoxColour("black") textColour("Gainsboro") $VBASIC
button bounds(1139,3,40,18) channel("ribon") text("Off", "On") $BUTTONS
}

//#Envelope Designer 

image channel("i28") bounds(2,350,200,100) plant("EnvDes") channel("Env") $PLANT {
    label channel("l27") bounds(0,2,200,16) text("Grain Envelope") $FONT

    //image file("./env2DSelect.svg") bounds(50,50,100,50)
    #define ENVSELECT items("Hamming, Hanning, Triangle, Blackman, Blackman Harris", "Gauss", "Pluck", "Reverse Pluck")
    image  bounds(2,30,200,75) colour(0,0,0,0) channel("envelopeMaker"){
        rslider channel("envPos") range(0,1,0,1,0.01) bounds(75,20,40,40) $BASIC
        
        combobox bounds(5,40,50,14) channel("envSelect_0") value(3) $ENVSELECT
        combobox bounds(10,20,50,14) channel("envSelect_1")value(5) $ENVSELECT
        combobox bounds(70,0,50,14) channel("envSelect_2") value(2) $ENVSELECT
        combobox bounds(130,20,50,14)channel("envSelect_3") value(6) $ENVSELECT
        combobox bounds(135,40,50,14) channel("envSelect_4") value(7) $ENVSELECT
    }


}

</Cabbage>

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; CSOUND CODE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0 -m0d --midi-key=4 --midi-velocity-amp=5 --displays ;sends MIDI note number and velocity to instr 1 as p4 and p5 respectively
</CsOptions>
<CsInstruments>

; Initialize the global variables. 
;sr = 48000
;gisr=sr
ksmps = 100  ;try 20 or 10 here if this is too slow for the FM implementation
nchnls = 2
0dbfs = 1

massign 0,5

gaSynL,gaSynR,gafinalL,gafinalR init 0   ;global synth sends to effects, need global to send all instances of instr 1 to FX
gaChorL,gaChorR,gaDelL,gaDelR,gaFXL,gaFXR init 0  ;global audio for chorus effect, feedback delay lines, reverb
gamicL,gamicR,gasfL,gasfR,gagrainFBdL,gagrainFBdR init 0
galiveL,galiveR,gasfgranL,gasfgranR,galivegrL,galivegrR init 0
gkstatus,gkdata1,gkdata2 init 0 ;initialize global MIDI settings
gkchan init 1 
gichnls init 0 ;globals for soundfile table loading
giReady init 0
gSfilepath init ""
gkTabLen init 2
gkTabLen1 init 2
gkRecordingActiveFlag,gkFileRecorded init 0
gkbend init 0
gkmidi init 60
gisize init 0 
gigrainTab init 0 
gaposition init 0 

;Used for live granulation module 
gaGrainInputBus[] init 2
gigrainTabL init 0
gifbTabL init 0
gienvtab init 0
gaOut[] init 2
gaIn[] init 2
gistarttab init 600
gaFb[] init 2
gaLiveGrainOut[] init 2 
gkLoopSize init 2000
gkWrapPoint init 1 


gkEnvs[] init 5 ;Fills table array with selectable envelopes

//#OPCODES

opcode	NextPowerOf2i,i,i ;from McCurdy, calculates next power-of-2 table length larger than input audio file
 iInVal	xin
 icount	=	1
 LOOP:
 if 2^icount>iInVal then
  goto DONE
 else
  icount	=	icount + 1
  goto LOOP
 endif
 DONE:
 	xout	2^icount
endop

opcode FileNameFromPath,S,S		; Extract a file name (as a string) from a full path (also as a string)
 Ssrc	xin				; Read in the file path string
 icnt	strlen	Ssrc			; Get the length of the file path string
 LOOP:					; Loop back to here when checking for a backslash
 iasc	strchar Ssrc, icnt		; Read ascii value of current letter for checking
 if iasc==92 igoto ESCAPE		; If it is a backslash, escape from loop
 loop_gt	icnt,1,0,LOOP		; Loop back and decrement counter which is also used as an index into the string
 ESCAPE:				; Escape point once the backslash has been found
 Sname	strsub Ssrc, icnt+1, -1		; Create a new string of just the file name
	xout	Sname			; Send it back to the caller instrument
endop



opcode ftmorfa, a, kai[]
    /* Acts like ftmorph, but gets an index at a rate*/
    kindex, aposition, itabs[] xin 
 
    inumber = lenarray(itabs)

    kindex limit kindex, 0, 1
    kScaled = kindex*(inumber-1)
    kTab1 = itabs[floor(kScaled)]
    kTab2 = itabs[limit(floor(kScaled)+1,0,inumber-1)]
    kMorph = kScaled%1

    a1 tablekt aposition, kTab1, 1,0,1
    a2 tablekt aposition, kTab2, 1,0,1
    xout a1*(1-kMorph) + a2*kMorph
endop


//#live audio input, record/play control
instr 1   
kplay   chnget  "sfplay"
gSfilepath chnget "openFile"
;gkseed random 0,1 ;CONSIDER ADDING THIS IF THE SEED VALUES IN RAND AND RANH DON"T SEEM TO WORK CORRECTLY
    
if changed(gSfilepath) == 1 then ;loads soundfile
    SIdentString sprintfk "file(\"%s\")", gSfilepath
    chnset SIdentString, "SFfiler"
    event   "i",3,0,0
endif
        
if changed(kplay) == 1 then ;turns on soundfile player
    if kplay=1 then 
    event "i",2,0,10000
    else
    turnoff2  2,0,.05
    endif
endif

kliveon chnget "liveon"
if changed(kliveon) == 1 then
  if kliveon=1 then
  turnoff2 20,2,0
  event "i",20,0,999999
  else 
  turnoff2 20,2,0
  endif
endif

klivegr chnget "livegr"
if changed(klivegr) == 1 then
  if klivegr=1 then
  turnoff2 21,2,0
  event "i",21,0,999999
  else 
  turnoff2 21,2,0
  turnoff2 25,0,0
  endif
endif
gkmidi = p4
gkrecord	chnget	"record"
gkplay		chnget	"play"
kRecStart	trigger	gkrecord,0.5,0
  if kRecStart==1 && gkRecordingActiveFlag==0 then
    event	"i",600,0,-1
    gkRecordingActiveFlag	=	1
  endif
  kPlayStart	trigger	gkplay,0.5,0
  if kPlayStart==1 && gkFileRecorded==1 then
    event	"i",601,ksmps/sr,3600
  endif

endin

instr 2
kloop chnget "sfloop"
iloop=i(kloop)
kingain chnget  "sfamp"
kEnv linsegr 0,.05,1,p3-.05,1,.1,0
    if gichnls==1 then
    a1 loscil 1,1,500,1,iloop
    gasfL=a1*kingain*kEnv
    gasfR=a1*kingain*kEnv
    elseif gichnls==2 then
    a1,a2 loscil 1,1,500,1,iloop
    gasfL=a1*kingain*kEnv
    gasfR=a2*kingain*kEnv
    endif
endin

instr 3
giTable ftgen 500,0,0,1,gSfilepath,0,0,0 ;load entire sound file into a table to use in GUI display
gichnls filenchnls  gSfilepath
ilen NextPowerOf2i filelen:i(gSfilepath)*sr
giTable1 ftgen 501,0,ilen,1,gSfilepath,0,0,1 ;load channel 1 into a table
if gichnls=2 then
giTable2 ftgen 502,0,ilen,1,gSfilepath,0,0,2 ;load channel two into another table
endif

giReady=1 ;default if no string has been loaded yet
gkTabLen init ftlen(giTable)/gichnls ;use to determine transposition
gkTabSr init ftsr(giTable)
Smessage sprintfk "file(%s)",gSfilepath ;display soundfile in soundfiler
endin

instr 4 ;creates MIDI note when grainstream is on
kgrainstream chnget "grainstream"
if changed2(kgrainstream)=1 then
 if kgrainstream=1 then
 event "i",14,0,999999;,kgrainstreamnote,kgrainstreamamp
 else turnoff2 14,1,0
 endif
endif
endin

//#Score Events 
instr 5 ;generate score events to drive simple grain generating instruments
    ;incoming MIDI note numbers and amp values set base 

kmv chnget  "MAmp"
iatt chnget "A"
idec chnget "D"
isus chnget "S"
irel chnget "R"
kADSR madsr iatt,idec,isus,irel
gkbend pchbend 0,1   ;default set at 1 semitones up and down

kss chnget "ScaleStart" ;MIDI pitch number from which any selected scale is calculated
kscale chnget "MasterScale"
if kscale == 1 then 
ksc=1 ;12 tone scale
elseif kscale == 2 then
ksc=.25 ;1/8 tones
elseif kscale == 3 then
ksc=.33333 ;1/6 tones
elseif kscale == 4 then
ksc=.5 ;1/4 tones
elseif kscale == 5 then
ksc=.66666 ;1/3 tones
elseif kscale == 6 then
ksc=1.714 ;7 tone octave
elseif kscale == 7 then
ksc=1.5 ;8 tone
elseif kscale == 8 then
ksc=1.3333 ;9 tone
elseif kscale == 9 then
ksc=1.2 ;10 tone
elseif kscale == 10 then
ksc=1.09091 ;11 tone
elseif kscale == 11 then
ksc=1.03448 ;11.6 tone
elseif kscale == 12 then
ksc=1.01695 ;11.8 tone
elseif kscale == 13 then
ksc=.98361 ;12.2 tone
elseif kscale == 14 then
ksc=.96774 ;12.4 tone
elseif kscale == 15 then
ksc=.9231 ;13 tone
elseif kscale == 16 then
ksc=.85714 ;14 tone
elseif kscale == 17 then
ksc=.8 ;15 tone
endif

;Random Note Stream Generation
kRNGon chnget "RNGon"
kRNGcps chnget "RNGrate"
kRNGcpsrand chnget "RNGraterand"
kRNGdev chnget "RNGdev"
kmicro chnget "RNGmicro"
kgliss chnget "RNGgliss"

if kRNGon == 0 then
kRNGnote=0
goto GrainCalc
endif

krateA randh (kRNGcps*kRNGcpsrand),kRNGcps,2 ;seed > 1 = random seeded by the system clock
knoterate=kRNGcps+krateA   ;sets master rate
if kgliss == 1 then
kRNGnote randi kRNGdev,knoterate,2
else
kRNGnote randh kRNGdev,knoterate,2
endif

if kmicro == 1 then
kRNGnote=int(kRNGnote) ;12 tone scale
elseif kmicro == 2 then ;all possible frequencies
elseif kmicro == 3 then
kRNGnote=(int(kRNGnote*2)*.5) ;1/4 tones
elseif kmicro == 4 then
kRNGnote=(int(kRNGnote*4)*.25) ;1/8 tones
elseif kmicro == 5 then
kRNGnote=int(kRNGnote)*2 ;Whole tone
elseif kmicro == 6 then
kRNGnote=int(kRNGnote)*3 ;minor 3rds
elseif kmicro == 7 then
kRNGnote=int(kRNGnote)*4 ;major 3rds
elseif kmicro == 8 then
kRNGnote=int(kRNGnote)*5 ;4ths
elseif kmicro == 9 then
kRNGnote=int(kRNGnote)*6 ;tritones
elseif kmicro == 10 then
kRNGnote=int(kRNGnote)*7 ;5ths
elseif kmicro == 11 then
kRNGnote=int(kRNGnote)*1.2 ;10 tone scale
elseif kmicro == 12 then
kRNGnote=int(kRNGnote)*.923 ;13 tone scale
elseif kmicro == 13 then
kRNGnote=int(kRNGnote)*.8 ;15 tone scale
elseif kmicro == 14 then
kRNGnote=int(kRNGnote)*1.715 ;7 tone scale
elseif kmicro == 15 then
kRNGnote=int(kRNGnote)*1.5 ;8 tone scale
endif

GrainCalc:
;dynamic filter section--generates dynamic data and passes through p-fields in the event opcode
kLLPon chnget "LLPon"
kLLPlp chnget "LLPlp"
kLLPlp port kLLPlp,.05
kLLPbp chnget "LLPbp"
kLLPbp port kLLPbp,.05
kLLPhp chnget "LLPhp"
kLLPhp port kLLPhp,.05
kLLPcfset chnget "LLPcfset"
koffset chnget "offset"
kbase chnget "base"
ktarget chnget "target"
kLLPQbase chnget "LLPQbase"
kLLPQtarget chnget "LLPQtarget"
icfA chnget "cfA"   ;generate dynamic filter data
icfD chnget "cfD"
icfS chnget "cfS"
icfR chnget "cfR"
iQA chnget "QA"
iQD chnget "QD"
iQS chnget "QS"
iQR chnget "QR"
kcfenv madsr icfA,icfD,icfS,icfR
kQenv madsr iQA,iQD,iQS,iQR
if kLLPcfset==1 then
kLLPcf=cpsmidinn(p4+koffset+(kcfenv*(p4+koffset+ktarget-(p4+koffset))))
else 
kLLPcf=cpsmidinn(kbase+(kcfenv*((kbase+ktarget)-kbase)))
endif
kLLPcf limit kLLPcf,50,25000
kLLPQ=kLLPQbase+(kQenv*(kLLPQtarget-kLLPQbase))
kLLPQ limit kLLPQ,.5,25

ifmA chnget "fmA"   ;generate dynamic FM data
ifmD chnget "fmD"
ifmS chnget "fmS"
ifmR chnget "fmR"
iindA chnget "indA"
iindD chnget "indD"
iindS chnget "indS"
iindR chnget "indR"
krat1 chnget "rat1"
krat2 chnget "rat2"
kind1 chnget "ind1"
kind2 chnget "ind2"
kfmenv madsr ifmA,ifmD,ifmS,ifmR ;these madsr objects give us data from 0-1, need to map to desired ratio and index values
kindenv madsr iindA,iindD,iindS,iindR
kratio=krat1+((krat2-krat1)*kfmenv)
kindex=kind1+((kind2-kind1)*kindenv)

krate   chnget  "rate"  ;retrieve the base grain rate form the GUI widgetArray
krdev   chnget  "rdev" ;retrieve the % deviation in base rate
kcpsdev chnget  "cpsdev"    ;retrieve the % deviation in sounding F
kampdev chnget  "ampdev"    ;retrieve the % amp deviation
kdur    chnget  "basedur"
kdurdev chnget  "durdev"

koverlap=krate*kdur    ;average overlap, current setting reap up to 1250 overlap
kfactor table   koverlap*.001,21,1 ;use as an amplitude factor to try to account for many grains sounding simultaneously

kwave chnget  "wave" ;gather GUI data to drive logic for wave selection amongst analog vco, wavetable, FM, and noise synthesis methods
kwaveprev chnget "waveprev"
kvco chnget  "vco"
kvcoprev chnget "vcoprev"
kfm chnget  "fm"
kfmprev chnget "fmprev"
knz chnget "nz"
knzprev chnget "nzprev"
kany=kwave+kvco+kfm+knz

kinstr6=(kwave*kwaveprev)
kinstr7=kinstr6+(kvco*kvcoprev)
kinstr8=kinstr7+(kfm*kfmprev)
kinstr9=kinstr8+(knz*knzprev) ;kinstr9 provides a total range value for a random function
if (kinstr9==0) then 

endif ;skip the rest if no synthesis is selected

krrate  randh   krate*krdev,krate,2   ;generate random values for rate deviation
kmetro=krate+krrate ;add the random values to the base rate to establish the master trigger clock
krpitch randh   kcpsdev,kmetro,2
kramp   randh   p5*kampdev,kmetro,2

;if kgrainstream=0 goto KEYS
;gkmidi=kss+((kgrainstreamnote-kss)*ksc)+krpitch+kRNGnote
;kamp=(kgrainstreamamp+kramp)*kmv*kfactor*kADSR
;goto DUR
;KEYS:
gkmidi=kss+((p4-kss)*ksc)+krpitch+kRNGnote
kamp=(p5+kramp)*kmv*kfactor*kADSR
;DUR:
kdurR   randh   kdur*kdurdev,kmetro,2
kdurfinal=kdur+kdurR
kinstrsel randh kinstr9,kmetro ;generates a random number between 0 and sum of all prevalence weights

kSyncSelProb[] init 4 //Contains an on or off for each instrument 
kselMode chnget "synthSelMode"


if kselMode == 1 then

    if kinstrsel>0 && kinstrsel<kinstr6 then ;these conditionals randomly assign the instrument number based on the specified weights and on/off status of each synth type
    ksynthsel=6
    elseif kinstrsel>kinstr6 && kinstrsel<kinstr7 then
    ksynthsel=7
    elseif kinstrsel>kinstr7 && kinstrsel<kinstr8 then
    ksynthsel=8
    elseif kinstrsel>kinstr8 && kinstrsel<kinstr9 then
    ksynthsel=9
    endif
    
elseif kselMode == 2 then
    kSyncSelProb = kSyncSelProb*0
    if (kwave*kwaveprev) > random:k(0,100) then 
        kSyncSelProb[0] = 1
    endif
    if  (kvco*kvcoprev) > random:k(0,100) then 
        kSyncSelProb[1] = 1
    endif
    if (kfm*kfmprev) > random:k(0,100) then 
        kSyncSelProb[2] = 1
    endif
    if (knz*knzprev) > random:k(0,100) then 
        kSyncSelProb[3] = 1
    endif 
endif
    
kpan1 chnget "pan"
kspread chnget "spread"
kpanr randh kspread,kmetro
kpan=1-(kpan1+kpanr)
kpan limit kpan,0,1

ktrigger    randomh 0,100,kmetro

trig:
ktrig   changed ktrigger
if (ktrig == 1) goto boom
goto end
boom:
if ksynthsel == 0 || kinstr9 == 0 goto end

if kselMode == 1 then 

event   "i",ksynthsel,0,kdurfinal,kamp,gkmidi,kpan,kLLPon,kLLPcf,kLLPQ,kLLPlp,kLLPbp,kLLPhp,kratio,kindex ;keep pitch as MIDI for further modification in the grain generators
elseif kselMode == 2 then 
    if kSyncSelProb[0] == 1 then 
    event   "i",6,0,kdurfinal,kamp,gkmidi,kpan,kLLPon,kLLPcf,kLLPQ,kLLPlp,kLLPbp,kLLPhp,kratio,kindex ;keep pitch as MIDI for further modification in the grain generators

    endif
   
    if kSyncSelProb[1] == 1 then 
        event   "i",7,0,kdurfinal,kamp,gkmidi,kpan,kLLPon,kLLPcf,kLLPQ,kLLPlp,kLLPbp,kLLPhp,kratio,kindex ;keep pitch as MIDI for further modification in the grain generators

    endif
    
    if kSyncSelProb[2] == 1 then 
        event   "i",8,0,kdurfinal,kamp,gkmidi,kpan,kLLPon,kLLPcf,kLLPQ,kLLPlp,kLLPbp,kLLPhp,kratio,kindex ;keep pitch as MIDI for further modification in the grain generators

    endif
    
    if kSyncSelProb[3] == 1 then 
        event   "i",9,0,kdurfinal,kamp,gkmidi,kpan,kLLPon,kLLPcf,kLLPQ,kLLPlp,kLLPbp,kLLPhp,kratio,kindex ;keep pitch as MIDI for further modification in the grain generators
    endif
    
endif

end:
ksfkey chnget "sfkey" ;this little bit of code will trigger the target SF granulation from the MIDI keyboard--won't stop when key released
 ;only 1 note polyphony as well since it restarts i11 each time, can maybe get polyphony by gathering other data besides target dur and sending to i1, or adding ADSR to turn off with key releases
 ;maybe move this code up by the kADSR, gather MIDI note-off info and then use turnoff2 for i11? otherwise grab an init rate pitch for i11 only
ktargetdur chnget "targetdur"
if changed(ksfkey)==1 then
  if ksfkey=1 then
    event "i",11,0,ktargetdur
  else
    //turnoff2 11,2,0
  endif
endif
endin

//#Synthesis Instruments 

instr 6 ;simple oscil grain synth p4=amp, p5=cps, p6=chnl1amp, p7-12 dynamic filter data, p13-14 ratio and index (p13-14 not used here)
kwaveamp chnget "waveamp"
;iatt chnget "att"
;iattsel chnget "attsel" ;add a combobox with other attack/decay shapes?
;iatt=p3*iatt
;isus=p3-(2*iatt)
;aenvA    linseg  0,iatt,1,isus,1,iatt,0
aenvA line 0, p3, 1
//aenv    table   aenvA,iattsel+200,1 ;reads through guassian window function for envelop

kenvpos = chnget:i("envPos")

itabs[] init lenarray(gkEnvs) 
    
itabs = gkEnvs
    
aenv ftmorfa kenvpos, aenvA, itabs       

ifn   chnget  "wavesel"
if (ifn==6) goto randbasics
if (ifn==22) goto randharmA
if (ifn==23) goto randharmB
if (ifn==24) goto randharmC
if (ifn==29) goto randstr
if (ifn==33) goto randbrass
if (ifn==43) goto randww
if (ifn==44) goto randall

if ifn<6 then
    ifn=ifn+100
    goto oscillator
  elseif ifn<22 then
    ifn=ifn+99
    goto oscillator
  elseif ifn<29 then
    ifn=ifn+96
    goto oscillator
  elseif ifn<33 then
    ifn=ifn+95
    goto oscillator
  elseif ifn<43 then
    ifn=ifn+94
    goto oscillator
endif

randbasics:
ifn random  101,105.98
  goto oscillator
randharmA:
ifn random  105,110.98
  goto oscillator
  randharmB:
ifn random  105,115.98
  goto oscillator
  randharmC:
ifn random  105,120.98
  goto oscillator
randstr:
ifn random  121,124.98
  goto oscillator
randbrass:
ifn random  125,127.98
  goto oscillator
randww:
ifn random  128,136.98
  goto oscillator
randall:
ifn random  101,136.98

oscillator:
;pitch ribbon
kribON chnget "ribon"
kribbon chnget "ribbon"
kribbon port kribbon,.025
if kribON==1 then
goto bend
elseif kribON==0 then
kribbon=0
endif

bend:
kup chnget "up"
kdown chnget "down"
if gkbend >= 0 then 
kbend=gkbend*kup   ;need to add up and down values
else
kbend=gkbend*kdown
endif
kbend port kbend,.025

;calculate vibrato
kvibdepth chnget "vibdepth"
kvibdepthmax chnget "vibdepthmax"
kvibcps chnget "vibcps"
kvibcpsmax chnget "vibcpsmax"
kvibrand chnget "vibrand"
kvcps randomi kvibcpsmax-(kvibcpsmax*kvibrand),kvibcpsmax+(kvibcpsmax*kvibrand),kvibcpsmax
kvamp randomi kvibdepthmax-(kvibdepthmax*kvibrand),kvibdepthmax+(kvibdepthmax*kvibrand),kvcps
kvib oscili kvamp*kvibdepth,kvcps*kvibcps,25
if kvibcps=0 then
 kvib=0
endif

a1  oscili   aenv*p4,cpsmidinn(p5+kvib+kribbon+kbend),ifn

if p7=0 goto stereo
alp,abp,ahp zdf_2pole_mode a1,p8,p9
aLLP=(alp*p10)+(abp*p11)+(ahp*p12)
a1 balance aLLP,a1

stereo:
aL=a1*p6*kwaveamp
aR=a1*(1-p6)*kwaveamp
gaSynL=gaSynL+aL
gaSynR=gaSynR+aR
endin

instr 7 ;simple vco2 grain synth p4=amp, p5=cps, p6=chnl1amp,p7-12 dynamic filter data, p13-14 ration and index (p13-14 not used here)
kanalogamp chnget "analogamp"
ivcosel chnget "vcosel"

aenvA line 0, p3, 1  
kenvpos = chnget:i("envPos")
itabs[] init lenarray(gkEnvs) 
itabs = gkEnvs
aenv ftmorfa kenvpos, aenvA, itabs 

if ivcosel=5 then ;random mode select
ivcorand random 1,4.99
ivcosel=int(ivcorand)
endif
if ivcosel=1 then ;mod assign
imode=0
aenv=aenv*.7
goto sound
elseif ivcosel=2 then
imode=10
aenv=aenv*.6
goto sound
elseif ivcosel=3 then
imode=12
goto sound
elseif ivcosel=4 then
imode=6
aenv=aenv*.05
goto sound
endif

sound:
;pitch ribbon
kribON chnget "ribon"
kribbon chnget "ribbon"
kribbon port kribbon,.025
if kribON==1 then
goto bend
elseif kribON==0 then
kribbon=0
endif

bend:
kup chnget "up"
kdown chnget "down"
if gkbend >= 0 then 
kbend=gkbend*kup   ;need to add up and down values
else
kbend=gkbend*kdown
endif
kbend port kbend,.025

;calculate vibrato
kvibdepth chnget "vibdepth"
kvibdepthmax chnget "vibdepthmax"
kvibcps chnget "vibcps"
kvibcpsmax chnget "vibcpsmax"
kvibrand chnget "vibrand"
kvcps randomi kvibcpsmax-(kvibcpsmax*kvibrand),kvibcpsmax+(kvibcpsmax*kvibrand),kvibcpsmax
kvamp randomi kvibdepthmax-(kvibdepthmax*kvibrand),kvibdepthmax+(kvibdepthmax*kvibrand),kvcps
kvib oscili kvamp*kvibdepth,kvcps*kvibcps,25

sound:
a1  vco2 p4,cpsmidinn(p5+kvib+kribbon+kbend),imode

a1 *= aenv

if p7=0 goto stereo
alp,abp,ahp zdf_2pole_mode a1,p8,p9
aLLP=(alp*p10)+(abp*p11)+(ahp*p12)
a1 balance aLLP,a1

stereo:
aL=a1*p6*kanalogamp
aR=a1*(1-p6)*kanalogamp
gaSynL=gaSynL+aL
gaSynR=gaSynR+aR
endin

instr 8 ;simple grain generating FM synth p4=amp, p5=cps, p6=chnl1amp, p7-12 dynamic filter data, p13-14 ration and index
kfmamp chnget "fmamp"
imodrand    chnget  "modrand"
imodrand=imodrand*p13
iindexrand  chnget  "indexrand"
iindexrand=iindexrand*p14
imodr   random  -imodrand,imodrand
iMOD=p13+imodr
indxr   random  -iindexrand,iindexrand
iINDEX=p14+indxr
  
aenvA line 0, p3, 1
kenvpos = chnget:i("envPos")
itabs[] init lenarray(gkEnvs) 
itabs = gkEnvs
aenv ftmorfa kenvpos, aenvA, itabs 

;pitch ribbon
kribON chnget "ribon"
kribbon chnget "ribbon"
kribbon port kribbon,.025
if kribON==1 then
goto ribbon
elseif kribON==0 then
kribbon=0
endif
ribbon:

bend:
kup chnget "up"
kdown chnget "down"
if gkbend >= 0 then 
kbend=gkbend*kup   ;need to add up and down values
else
kbend=gkbend*kdown
endif
kbend port kbend,.025

;calculate vibrato
kvibdepth chnget "vibdepth"
kvibdepthmax chnget "vibdepthmax"
kvibcps chnget "vibcps"
kvibcpsmax chnget "vibcpsmax"
kvibrand chnget "vibrand"
kvcps randomi kvibcpsmax-(kvibcpsmax*kvibrand),kvibcpsmax+(kvibcpsmax*kvibrand),kvibcpsmax
kvamp randomi kvibdepthmax-(kvibdepthmax*kvibrand),kvibdepthmax+(kvibdepthmax*kvibrand),kvcps
kvib oscili kvamp*kvibdepth,kvcps*kvibcps,25

a1 foscil  aenv*p4,cpsmidinn(p5+kvib+kribbon+kbend),1,iMOD,iINDEX,105
if p7=0 goto stereo ;dynamic filter section
alp,abp,ahp zdf_2pole_mode a1,p8,p9
aLLP=(alp*p10)+(abp*p11)+(ahp*p12)
a1 balance aLLP,a1

stereo:
aL=a1*p6*kfmamp
aR=a1*(1-p6)*kfmamp
gaSynL=gaSynL+aL
gaSynR=gaSynR+aR
endin

instr 9 ;noise grain ;add LLP?
knzamp chnget "nzamp"
inzsel chnget "nzsel"

aenvA line 0, p3, 1
kenvpos = chnget:i("envPos")
itabs[] init lenarray(gkEnvs) 
itabs = gkEnvs
aenv ftmorfa kenvpos, aenvA, itabs 

if inzsel=1 goto white
if inzsel=2 goto pink
if inzsel=3 goto gaus
irnd random 1,2.999
ichoice=int(irnd)
if ichoice=0 goto white
if ichoice=1 goto pink
if ichoice=2 goto gaus

white:
a1 rand aenv*p4
goto FILT
pink:
a1 pinkish aenv*p4
goto FILT
gaus:
a1 gauss k(aenv)*p4 

FILT:
inzfilt chnget "nzfilt" 
if inzfilt=0 goto LLP
inzfiltsel chnget "nzfiltsel"
inzfiltF1 chnget "nzfiltF1"
inzfiltF2 chnget "nzfiltF2"
if inzfiltF1<inzfiltF2 goto QCOMPARE
inzfiltFtemp=inzfiltF1 ;swap values if F1 is higher than F2
inzfiltF1=inzfiltF2
inzfiltF2=inzfiltFtemp

QCOMPARE:
inzfiltQ1 chnget "nzfiltQ1"
inzfiltQ2 chnget "nzfiltQ2"
if inzfiltQ1<inzfiltQ2 goto FILTNEXT
inzfiltQtemp=inzfiltQ1
inzfiltQ1=inzfiltQ2
inzfiltQ2=inzfiltQtemp

FILTNEXT:
icf=rnd(inzfiltF2-inzfiltF1)
ibw=rnd(inzfiltQ2-inzfiltQ1)
if inzfiltsel=4 then ;random
inzfiltsel=int(rnd(2.99))+1
endif

if inzfiltsel=1 then ;bandpass
afilt butterbp a1,inzfiltF1+icf,(inzfiltF1+icf)/(ibw+inzfiltQ1)
a1 balance afilt,a1
elseif inzfiltsel=2 then ;lowpass
afilt butterlp a1,inzfiltF1+icf
a1 balance afilt,a1
elseif inzfiltsel=3 then ;highpass
afilt butterhp a1,inzfiltF1+icf
a1 balance afilt,a1
endif

LLP:
;filt: ;this code imposes the latched lowpass filter if it is turned on
if p7=0 goto stereo
alp,abp,ahp zdf_2pole_mode a1,p8,p9
aLLP=(alp*p10)+(abp*p11)+(ahp*p12)
a1 balance aLLP,a1

stereo:
aL=a1*p6*knzamp
aR=a1*(1-p6)*knzamp
gaSynL=gaSynL+aL
gaSynR=gaSynR+aR
endin

instr 10 ;soundfile granulation data generator to control i15 (granulator)
krate   chnget  "rate"  ;retrieve the base grain rate form the GUI widgetArray
krdev   chnget  "rdev" ;retrieve the % deviation in base rate
kampdev chnget  "ampdev"    ;retrieve the % amp deviation
kdur    chnget  "basedur"
kdurdev chnget  "durdev"
kscrub chnget "scrub"
kscrubr chnget "scrubr"
kscrubT chnget "scrubT"
kscrubTr chnget "scrubTr"
ksfamp chnget "sfamp"
kmv chnget "MAmp"
kmv port kmv,.05
kss chnget "ScaleStart"

koverlap=krate*kdur    ;average overlap, current setting reaps up to 1250 overlap
kfactor table   koverlap*.001,21,1 ;use as an amplitude factor to try to account for many grains sounding simultaneously
krrate  randh   krate*krdev,krate   ;generate random values for rate deviation
kmetro=krate+krrate ;add the random values to the base rate to establish the master trigger clock
kribON chnget "ribon"  ;pitch ribbon
kribbon chnget "ribbon"
kribbon port kribbon,.025
if kribON==1 then
goto ribbon
elseif kribON==0 then
kribbon=0
endif
ribbon:

bend:
kup chnget "up"
kdown chnget "down"
if gkbend >= 0 then 
kbend=gkbend*kup   ;need to add up and down values
else
kbend=gkbend*kdown
endif
kbend port kbend,.025
kTrand randh kscrubTr,kmetro
kTtemp=kscrubT+kTrand
ksfT limit kTtemp,-36,36
kmidi=ksfT+kss+kribbon+kbend ;for scrubbing, assume no transposition is MIDI note defined by scale start value ("Tune From")
kramp   randh   ksfamp*kampdev,kmetro
kamp=(ksfamp+kramp)*kmv*kfactor
kdurR   randh   kdur*kdurdev,kmetro
kdurfinal=kdur+kdurR
kpan1 chnget "pan"
kspread chnget "spread"
kpanr randh kspread,kmetro
kpan=1-(kpan1+kpanr)
kpan limit kpan,0,1
kscrubrand randh kscrubr,kmetro
ksfloctemp=kscrub+kscrubrand
ksfloc limit ksfloctemp,0,1
ktrigger    randomh 0,100,kmetro
if changed(ktrigger)==1 goto boom
goto end
boom:
event   "i",15,0,kdurfinal,kamp,kpan,ksfloc,kmidi ;ksfT expressed as MIDI note deviation from 60
end:
endin

//#SF Grain

instr 11 ;soundfile granulation data generator to control i15 (granulator)
krate   chnget  "rate"  ;retrieve the base grain rate form the GUI widgetArray
krdev   chnget  "rdev" ;retrieve the % deviation in base rate
kampdev chnget  "ampdev"    ;retrieve the % amp deviation
kdur    chnget  "basedur"
kdurdev chnget  "durdev"
iscrub chnget "scrub"
iscrubr chnget "scrubr"
iscrubT chnget "scrubT"
iscrubTr chnget "scrubTr"
ksfamp chnget "sfamp"
kmv chnget "MAmp"
kmv port kmv,.05
kss chnget "ScaleStart"
itargetL chnget "targetL" ;the following code simply modifies the location and transposition data over time, the rest is identical to i10
itargetLr chnget "targetLr"
itargetT chnget "targetT"
itargetTr chnget "targetTr"
kscrubmv line iscrub,p3,itargetL
kscrubrmv line iscrubr,p3,itargetLr
kscrubTmv line iscrubT,p3,itargetT
kscrubTrmv line iscrubTr,p3,itargetTr

koverlap=krate*kdur    ;average overlap, current setting reap up to 1250 overlap
kfactor table   koverlap*.001,21,1 ;use as an amplitude factor to try to account for many grains sounding simultaneously
krrate  randh   krate*krdev,krate   ;generate random values for rate deviation
kmetro=krate+krrate ;add the random values to the base rate to establish the master trigger clock
kribON chnget "ribon"  ;pitch ribbon
kribbon chnget "ribbon"
kribbon port kribbon,.025
if kribON==1 then
goto ribbon
elseif kribON==0 then
kribbon=0
endif
ribbon:

bend:
kup chnget "up"
kdown chnget "down"
if gkbend >= 0 then 
kbend=gkbend*kup   ;need to add up and down values
else
kbend=gkbend*kdown
endif
kbend port kbend,.025
kTrand randh kscrubTrmv,kmetro
kTtemp=kscrubTmv+kTrand
ksfT limit kTtemp,-36,36

ksfkey chnget "sfkey"
if ksfkey=1 then
kmidi=gkmidi+ksfT+kribbon+kbend

else
kmidi=ksfT+kss+kribbon+kbend ;for scrubbing, assume no transposition is MIDI note defined by scale start value ("Tune From")
endif

kramp   randh   ksfamp*kampdev,kmetro ;grain data
kamp=(ksfamp+kramp)*kmv*kfactor
kdurR   randh   kdur*kdurdev,kmetro
kdurfinal=kdur+kdurR
kpan1 chnget "pan"
kspread chnget "spread"
kpanr randh kspread,kmetro
kpan=1-(kpan1+kpanr)
kpan limit kpan,0,1
kscrubrand randh kscrubrmv,kmetro
ksfloctemp=kscrubmv+kscrubrand
ksfloc limit ksfloctemp,0,1
ktrigger    randomh 0,100,kmetro
if changed(ktrigger)==1 goto boom
goto end
boom:
event   "i",15,0,kdurfinal,kamp,kpan,ksfloc,kmidi ;ksfT expressed as MIDI note deviation from 60
end:
endin

instr 12 ;soundfile and live audio granulation controls
kscrubon chnget "scrubon"
ktargeton chnget "targeton"
ktargetdur chnget "targetdur"
if changed(kscrubon)==1 then
  if kscrubon=1 then
    turnoff2 10,2,0
    event "i",10,0,999999
  else
    turnoff2 10,2,0
  endif
endif

if changed(ktargeton)==1 then
  if ktargeton=1 then
    turnoff2 11,2,0
    event "i",11,0,ktargetdur
  else
    turnoff2 11,2,0
  endif
endif
endin

instr 14 ;generate score events to drive simple grain generating instruments
    ;incoming MIDI note numbers and amp values set base 
knote chnget "grainstreamnote"
kamp chnget "grainstreamamp"
kmv chnget  "MAmp"
iatt chnget "A"
idec chnget "D"
isus chnget "S"
irel chnget "R"
kADSR madsr iatt,idec,isus,irel
gkbend pchbend 0,1   ;default set at 1 semitones up and down

kss chnget "ScaleStart" ;MIDI pitch number from which any selected scale is calculated
kscale chnget "MasterScale"
if kscale == 1 then 
ksc=1 ;12 tone scale
elseif kscale == 2 then
ksc=.25 ;1/8 tones
elseif kscale == 3 then
ksc=.33333 ;1/6 tones
elseif kscale == 4 then
ksc=.5 ;1/4 tones
elseif kscale == 5 then
ksc=.66666 ;1/3 tones
elseif kscale == 6 then
ksc=1.714 ;7 tone octave
elseif kscale == 7 then
ksc=1.5 ;8 tone
elseif kscale == 8 then
ksc=1.3333 ;9 tone
elseif kscale == 9 then
ksc=1.2 ;10 tone
elseif kscale == 10 then
ksc=1.09091 ;11 tone
elseif kscale == 11 then
ksc=1.03448 ;11.6 tone
elseif kscale == 12 then
ksc=1.01695 ;11.8 tone
elseif kscale == 13 then
ksc=.98361 ;12.2 tone
elseif kscale == 14 then
ksc=.96774 ;12.4 tone
elseif kscale == 15 then
ksc=.9231 ;13 tone
elseif kscale == 16 then
ksc=.85714 ;14 tone
elseif kscale == 17 then
ksc=.8 ;15 tone
endif

;Random Note Stream Generation
kRNGon chnget "RNGon"
kRNGcps chnget "RNGrate"
kRNGcpsrand chnget "RNGraterand"
kRNGdev chnget "RNGdev"
kmicro chnget "RNGmicro"
kgliss chnget "RNGgliss"

if kRNGon == 0 then
kRNGnote=0
goto GrainCalc
endif

krateA randh (kRNGcps*kRNGcpsrand),kRNGcps,2 ;seed > 1 = random seeded by the system clock
knoterate=kRNGcps+krateA   ;sets master rate
if kgliss == 1 then
kRNGnote randi kRNGdev,knoterate,2
else
kRNGnote randh kRNGdev,knoterate,2
endif

if kmicro == 1 then
kRNGnote=int(kRNGnote) ;12 tone scale
elseif kmicro == 2 then ;all possible frequencies
elseif kmicro == 3 then
kRNGnote=(int(kRNGnote*2)*.5) ;1/4 tones
elseif kmicro == 4 then
kRNGnote=(int(kRNGnote*4)*.25) ;1/8 tones
elseif kmicro == 5 then
kRNGnote=int(kRNGnote)*2 ;Whole tone
elseif kmicro == 6 then
kRNGnote=int(kRNGnote)*3 ;minor 3rds
elseif kmicro == 7 then
kRNGnote=int(kRNGnote)*4 ;major 3rds
elseif kmicro == 8 then
kRNGnote=int(kRNGnote)*5 ;4ths
elseif kmicro == 9 then
kRNGnote=int(kRNGnote)*6 ;tritones
elseif kmicro == 10 then
kRNGnote=int(kRNGnote)*7 ;5ths
elseif kmicro == 11 then
kRNGnote=int(kRNGnote)*1.2 ;10 tone scale
elseif kmicro == 12 then
kRNGnote=int(kRNGnote)*.923 ;13 tone scale
elseif kmicro == 13 then
kRNGnote=int(kRNGnote)*.8 ;15 tone scale
elseif kmicro == 14 then
kRNGnote=int(kRNGnote)*1.715 ;7 tone scale
elseif kmicro == 15 then
kRNGnote=int(kRNGnote)*1.5 ;8 tone scale
endif

GrainCalc:
;dynamic filter section--generates dynamic data and passes through p-fields in the event opcode
kLLPon chnget "LLPon"
kLLPlp chnget "LLPlp"
kLLPlp port kLLPlp,.05
kLLPbp chnget "LLPbp"
kLLPbp port kLLPbp,.05
kLLPhp chnget "LLPhp"
kLLPhp port kLLPhp,.05
kLLPcfset chnget "LLPcfset"
koffset chnget "offset"
kbase chnget "base"
ktarget chnget "target"
kLLPQbase chnget "LLPQbase"
kLLPQtarget chnget "LLPQtarget"
icfA chnget "cfA"   ;generate dynamic filter data
icfD chnget "cfD"
icfS chnget "cfS"
icfR chnget "cfR"
iQA chnget "QA"
iQD chnget "QD"
iQS chnget "QS"
iQR chnget "QR"
kcfenv madsr icfA,icfD,icfS,icfR
kQenv madsr iQA,iQD,iQS,iQR
if kLLPcfset==1 then
kLLPcf=cpsmidinn(knote+koffset+(kcfenv*(knote+koffset+ktarget-(knote+koffset))))
else 
kLLPcf=cpsmidinn(kbase+(kcfenv*((kbase+ktarget)-kbase)))
endif
kLLPcf limit kLLPcf,50,25000
kLLPQ=kLLPQbase+(kQenv*(kLLPQtarget-kLLPQbase))
kLLPQ limit kLLPQ,.5,25

ifmA chnget "fmA"   ;generate dynamic FM data
ifmD chnget "fmD"
ifmS chnget "fmS"
ifmR chnget "fmR"
iindA chnget "indA"
iindD chnget "indD"
iindS chnget "indS"
iindR chnget "indR"
krat1 chnget "rat1"
krat2 chnget "rat2"
kind1 chnget "ind1"
kind2 chnget "ind2"
kfmenv madsr ifmA,ifmD,ifmS,ifmR ;these madsr objects give us data from 0-1, need to map to desired ratio and index values
kindenv madsr iindA,iindD,iindS,iindR
kratio=krat1+((krat2-krat1)*kfmenv)
kindex=kind1+((kind2-kind1)*kindenv)

krate   chnget  "rate"  ;retrieve the base grain rate form the GUI widgetArray
krdev   chnget  "rdev" ;retrieve the % deviation in base rate
kcpsdev chnget  "cpsdev"    ;retrieve the % deviation in sounding F
kampdev chnget  "ampdev"    ;retrieve the % amp deviation
kdur    chnget  "basedur"
kdurdev chnget  "durdev"

koverlap=krate*kdur    ;average overlap, current setting reap up to 1250 overlap
kfactor table   koverlap*.001,21,1 ;use as an amplitude factor to try to account for many grains sounding simultaneously

kwave chnget  "wave" ;gather GUI data to drive logic for wave selection amongst analog vco, wavetable, FM, and noise synthesis methods
kwaveprev chnget "waveprev"
kvco chnget  "vco"
kvcoprev chnget "vcoprev"
kfm chnget  "fm"
kfmprev chnget "fmprev"
knz chnget "nz"
knzprev chnget "nzprev"
kany=kwave+kvco+kfm+knz

kinstr6=(kwave*kwaveprev)
kinstr7=kinstr6+(kvco*kvcoprev)
kinstr8=kinstr7+(kfm*kfmprev)
kinstr9=kinstr8+(knz*knzprev) ;kinstr9 provides a total range value for a random function
if (kinstr9==0) then 

endif ;skip the rest if no synthesis is selected

krrate  randh   krate*krdev,krate,2   ;generate random values for rate deviation
kmetro=krate+krrate ;add the random values to the base rate to establish the master trigger clock
krpitch randh   kcpsdev,kmetro,2
gkmidi=kss+((knote-kss)*ksc)+krpitch+kRNGnote
kramp   randh   kamp*kampdev,kmetro,2
kamp=(kamp+kramp)*kmv*kfactor*kADSR
kdurR   randh   kdur*kdurdev,kmetro,2
kdurfinal=kdur+kdurR
kinstrsel randh kinstr9,kmetro ;generates a random number between 0 and sum of all prevalence weights

kSyncSelProb[] init 4 //Contains an on or off for each instrument 
kselMode chnget "synthSelMode"


if kselMode == 1 then

    if kinstrsel>0 && kinstrsel<kinstr6 then ;these conditionals randomly assign the instrument number based on the specified weights and on/off status of each synth type
    ksynthsel=6
    elseif kinstrsel>kinstr6 && kinstrsel<kinstr7 then
    ksynthsel=7
    elseif kinstrsel>kinstr7 && kinstrsel<kinstr8 then
    ksynthsel=8
    elseif kinstrsel>kinstr8 && kinstrsel<kinstr9 then
    ksynthsel=9
    endif
    
elseif kselMode == 2 then
    kSyncSelProb = kSyncSelProb*0
    if (kwave*kwaveprev) > random:k(0,100) then 
        kSyncSelProb[0] = 1
    endif
    if  (kvco*kvcoprev) > random:k(0,100) then 
        kSyncSelProb[1] = 1
    endif
    if (kfm*kfmprev) > random:k(0,100) then 
        kSyncSelProb[2] = 1
    endif
    if (knz*knzprev) > random:k(0,100) then 
        kSyncSelProb[3] = 1
    endif 
endif
    
kpan1 chnget "pan"
kspread chnget "spread"
kpanr randh kspread,kmetro
kpan=1-(kpan1+kpanr)
kpan limit kpan,0,1

ktrigger    randomh 0,100,kmetro

trig:
ktrig   changed ktrigger
if (ktrig == 1) goto boom
goto end
boom:
if ksynthsel == 0 || kinstr9 == 0 goto end

if kselMode == 1 then 

event   "i",ksynthsel,0,kdurfinal,kamp,gkmidi,kpan,kLLPon,kLLPcf,kLLPQ,kLLPlp,kLLPbp,kLLPhp,kratio,kindex ;keep pitch as MIDI for further modification in the grain generators
elseif kselMode == 2 then 
    if kSyncSelProb[0] == 1 then 
    event   "i",6,0,kdurfinal,kamp,gkmidi,kpan,kLLPon,kLLPcf,kLLPQ,kLLPlp,kLLPbp,kLLPhp,kratio,kindex ;keep pitch as MIDI for further modification in the grain generators

    endif
   
    if kSyncSelProb[1] == 1 then 
        event   "i",7,0,kdurfinal,kamp,gkmidi,kpan,kLLPon,kLLPcf,kLLPQ,kLLPlp,kLLPbp,kLLPhp,kratio,kindex ;keep pitch as MIDI for further modification in the grain generators

    endif
    
    if kSyncSelProb[2] == 1 then 
        event   "i",8,0,kdurfinal,kamp,gkmidi,kpan,kLLPon,kLLPcf,kLLPQ,kLLPlp,kLLPbp,kLLPhp,kratio,kindex ;keep pitch as MIDI for further modification in the grain generators

    endif
    
    if kSyncSelProb[3] == 1 then 
        event   "i",9,0,kdurfinal,kamp,gkmidi,kpan,kLLPon,kLLPcf,kLLPQ,kLLPlp,kLLPbp,kLLPhp,kratio,kindex ;keep pitch as MIDI for further modification in the grain generators
    endif
    
endif

end:
ksfkey chnget "sfkey" ;this little bit of code will trigger the target SF granulation from the MIDI keyboard--won't stop when key released
 ;only 1 note polyphony as well since it restarts i11 each time, can maybe get polyphony by gathering other data besides target dur and sending to i1, or adding ADSR to turn off with key releases
 ;maybe move this code up by the kADSR, gather MIDI note-off info and then use turnoff2 for i11? otherwise grab an init rate pitch for i11 only
ktargetdur chnget "targetdur"
if changed(ksfkey)==1 then
  if ksfkey=1 then
    event "i",11,0,ktargetdur
  else
    //turnoff2 11,2,0
  endif
endif
endin

instr 15 ;makes a single grain from a sampled soundfile and add to the summed synthetic audio that is routed to the FX
;p4=amp, p5=pan, p6=sfloc, p7=sfT (no T is midi 60)
iatt chnget "att"
iattsel chnget "attsel" ;add a combobox with other attack/decay shapes?
iatt=p3*iatt
isus=p3-(2*iatt)
aenvA line 0, p3, 1
kenvpos = chnget:i("envPos")
itabs[] init lenarray(gkEnvs)    
itabs = gkEnvs 
aenv ftmorfa kenvpos, aenvA, itabs 

ilen=i(gkTabLen)
isr = i(gkTabSr)
istart=p6*ilen
kss chnget "ScaleStart"
inote=i(kss)

if gichnls=2 then

  iTfactor= pow(2,(p7-60)/12) ;determine transposition factor
  iend=istart+(p3*iTfactor*isr) 
  aindex line istart,p3,iend

  ichnl random -1,1
  if ichnl>0 then
  asample tablei aindex,giTable1,0 
  else 
  asample tablei aindex,giTable2,0
  goto envelope
  endif
elseif gichnls=1 then
   iTfactor= pow(2,(p7-60)/12)
  iend=istart+(p3*isr*iTfactor)
  aindex line istart,p3,iend
  asample tablei aindex,giTable1,0 ;have table mode set to read raw index points
endif 

envelope:
a1=asample*aenv ;envelope
aL=a1*p5
aR=a1*(1-p5)
gasfgranL=gasfgranL+aL
gasfgranR=gasfgranR+aR
endin

//#Live Granulation

instr liveGrainInit 
    iMaxTime = 20
    giSize = iMaxTime*sr
    gigrainTabL = 1051
    gifbTabL = 1590
    gigrainTabR = 1502
    gifbTabR = 1591
    gigrainTabL ftgen 1501, 0, giSize, -2, 0 //Granulation buffer
    gifbTabL ftgen 1590, 0, giSize, -2, 0 // Feedback buffer
    gigrainTabR ftgen 1502, 0, giSize, -2, 0 //Granulation buffer
    gifbTabR ftgen 1591, 0, giSize, -2, 0 // Feedback buffer
  
    iwinsize = 4096 
   
    giHamming ftgenonce gistarttab+1, 0, iwinsize, -20, 1 //Hamming
    giHanning ftgenonce gistarttab+2, 0, iwinsize, -20, 2 //Hanning
    giTriangle ftgenonce gistarttab+3, 0, iwinsize, -20, 3 //Triangle
    giBlackman ftgenonce gistarttab+4, 0, iwinsize, -20, 4 //Blackman
    giBlackmanHarris ftgenonce gistarttab+5, 0, iwinsize, -20, 5 //Blackman-Harris
    giGauss ftgenonce gistarttab+6, 0, iwinsize, -20, 6 //Gauss   
    
    giPluck ftgenonce gistarttab+7, 0, iwinsize, -5, 0.0001, iwinsize*0.1, 1, iwinsize*0.8, 0.0001  //pluck
    giReversePluck ftgenonce gistarttab+8, 0, iwinsize, -5, 0.0001, iwinsize*081, 1, iwinsize*0.1, 0.0001  //reversePluck
    
    gkPosibleEnvs[] fillarray giHamming, giHanning, giTriangle, giBlackman, giBlackmanHarris, giGauss, giPluck, giReversePluck
    
endin

instr liveGrainStateCheck
    
    kliveGrainState chnget "liveGrainState"
    
    if changed2:k(kliveGrainState)==1 && kliveGrainState == 1 then 
       event "i", "liveGrainLoop", 0, 999999
    endif 
    
    if changed2:k(kliveGrainState)==1 && kliveGrainState == 0 then 
        turnoff2 "liveGrainLoop", 0, 1
    endif 

endin 


instr liveGrainWriteTab
    aSyncLast init 0 
    gkLoopSize chnget "liveloopSize"
    gkLoopSize=gkLoopSize*1000
    kFreeze init 0
    gaSamp init 0
    aOld[] init 2
    kFreeze chnget "livefreeze"
    aIn[] init 2
    
    gaLiveGrainOut[] init 2 
    kinlevel chnget "intolive"
    
    aIn in 
    aIn = (aIn*a(kinlevel)+gaGrainInputBus) * chnget:k("liveGrainState")
    gaGrainInputBus = gaGrainInputBus*0      
    kstart init 1             
        
    kFbRateAdjust = 1/chnget("liveGrainRate")
    irate = 1/(giSize/sr) 
    
    if kFreeze == 1 goto FREEZESKIP
    aSync phasor irate 
    gaSync += aSync-aSyncLast
    gkWrapPoint = (gkLoopSize/1000)*sr/giSize
    gaSync wrap gaSync, 0, gkWrapPoint
    aSyncLast = aSync 

    koverdub chnget "liveoverdub"
    
    aOld[0] ptable3, gaSync, gigrainTabL, 1, 0, 1 
    aOld[1] ptable3, gaSync, gigrainTabR, 1, 0, 1   
    
    kpanMode chnget "livepanMode"
    
    if kpanMode == 2 then
    
    ptablew aIn[0]*(1-koverdub)+aOld[0]*(koverdub), gaSync, gigrainTabL, 1, 0, 1 
    ptablew aIn[1]*(1-koverdub)+aOld[1]*(koverdub), gaSync, gigrainTabR, 1, 0, 1
    
    endif
    
    if kpanMode == 1 then 
    
    ptablew (aIn[0]+aIn[1])*(1-koverdub)+aOld[0]*(koverdub), gaSync, gigrainTabL, 1, 0, 1 
    ptablew (aIn[0]+aIn[1])*(1-koverdub)+aOld[1]*(koverdub), gaSync, gigrainTabR, 1, 0, 1
     
    endif 
    
    FREEZESKIP:
    gaFb[0] butterhp gaFb[0], k(25)
    gaFb[1] butterhp gaFb[1], k(25) 
    gaFb[0] butterhp gaFb[0], k(50)
    gaFb[1] butterhp gaFb[1], k(50) 

    
    gaFb[0] compress gaFb[0], gaFb[0], 0, 48, 60, 3, 0.1, 0.1, 0.02
    gaFb[1] compress gaFb[1], gaFb[0], 0, 48, 60, 3, 0.1, 0.1, 0.02
    
    gaFb = gaFb*(0.5+limit(kFbRateAdjust*0.5,0,0.5)) 
    
    irate = 1/(giSize/sr) 
    
    gaSyncFb phasor irate 

    ptablew gaFb[0], gaSyncFb, gifbTabL, 1, 0, 1  
    ptablew gaFb[1], gaSyncFb, gifbTabR, 1, 0, 1

    gaFb = gaFb*0
    
    kupdateviz metro 5
    itimeStart times 
    know times
    if  kupdateviz == 1 && kstart == 0 && itimeStart-know > 0.5 then    
       //chnset sprintfk("tableNumber(%d)", 1501),"liveGrainInputLId"
       //chnset sprintfk("tableNumber(%d)", 1502),"liveGrainInputRId"
    endif
    
    kstart = 0
endin


instr liveGrainLoop
    krate init chnget:i("rate")
    
    kfb chnget "livefeedback"
    kfbRand chnget "livefeedbackRand"
    
    kfbdel chnget "livefeedbackdelay"
    kfbdel=kfbdel*gkLoopSize*.001  ;make FB delay relative to maximum delay/buffer size--gkLoopSize is in ms
    kfbdelRand chnget "livefeedbackdelayRand"
    
    kdelay chnget "livedelay"    
    kdelayRandom chnget "livedelayRandom"
   
    kwindowPos chnget "livewindowPos"
    kwindowPosRandom chnget "livewindowPosRandom"
    
    ktranspose chnget "livetranspose"
    ktransposeRandom chnget "livetransposeRandom"
    
    kgrainSize chnget "livegrainSize" 
    
    kgrainSizeRandom chnget "livegrainSizeRandom"
    
    krate chnget "liverate"    
    krateRandom chnget "liverateRandom"
    
    kpanPos chnget "livepanCenter"    
    kpanRandom chnget "livepanRandom"
    kpanMode chnget "livepanMode"
    
    krate += random:k(0,-1)*krate*krateRandom

    ktrig metro krate          
        kfb += random:k(0,-1)*kfb*kfbRand       
        kfbdel += random:k(0,-1)*kfbdelRand
        kgrainSize += random:k(0,-1)*kgrainSize*kgrainSizeRandom 
        kdelay += (random:k(0,-1)*kdelay*kdelayRandom)  
        kdelay*= (gkLoopSize) 
        kgraintime = kgrainSize
;                kgraintime = kgrainSize/1000
        kwindowPos += random:k(0,-1)*kwindowPos*kwindowPosRandom
        ktranspose += random:k(1,-1)*ktransposeRandom
        kpanPos = limit(kpanPos+random:k(-kpanRandom,kpanRandom),0,1)
    if (ktrig == 1) then 
       event "i", "makeGrain", 0, kgraintime+kfbdel+0.01, kgraintime, k(gaSync), kdelay, ktranspose, kwindowPos, k(gaSyncFb), kfb, kfbdel, kpanMode, kpanPos
    
    endif

endin

instr makeGrain
    aFb[] init 2
    idur = p4    
    istart = p5    
    idelay = p6    
    itranspose = p7    
    kenvpos = p8    
    istartFb = p9
    ifb = p10
    ifbdel = p11
    isteroMode = p12
    iPosition = p13

    irate = pow(2,itranspose/12)    
    iMinDelay = (ksmps*4)/giSize
    
    aGrain[] init 2    
    aFb[] init 2   
    aEnvProgress line 0, idur, 1   
    itabs[] init lenarray(gkEnvs) 
    itabs = gkEnvs
    
    aEnv ftmorfa kenvpos, aEnvProgress, itabs
    idurphs = idur*sr/giSize
    aNoClick adsr p4*0.01, p4*0.95, 1, p4*0.01    
    aEnv *= aNoClick
    iOffset = (idelay/1000*sr)/giSize
    iendOld = istart + idurphs    
    iendNew = (istart-iOffset) + idurphs*irate   
    if (iendNew > iendOld) then   
        iOffset = iendOld-iendNew   
    endif

    iOffset limit iOffset, iMinDelay, (i(gkLoopSize)/1000*sr-ksmps*2)/giSize      
    aPhs phasor 1/(giSize/sr)*irate    
    aPos = istart - iOffset + aPhs   
    aPos wrap aPos, 0, gkWrapPoint   
    aPosFb = istartFb - iOffset + aPhs    
    aGrain[0] ptable3 aPos, gigrainTabL, 1, 0, 1    
    aFb[0] ptable3 aPosFb, gifbTabL, 1, 0, 1 
    aGrain[1] ptable3 aPos, gigrainTabR, 1, 0, 1
    aFb[1] ptable3 aPosFb, gifbTabR, 1, 0, 1
    aGrain = aGrain+aFb*(ifb*0.1+0.9)

    if isteroMode <= 1 then 
        //Summed Mono with random spread
        aMono = (aGrain[0]+aGrain[1])*0.7
        aGrain[0], aGrain[1] pan2 aMono, iPosition
    elseif isteroMode == 2 then
        //Stereo with changing Mix based of position
        aGrain[0] = aGrain[0]*pow((1-iPosition),0.5)
        aGrain[1] = aGrain[1]*pow(iPosition,0.5)
    endif
    
    aGrain = aGrain * aEnv           
    gaLiveGrainOut = gaLiveGrainOut + aGrain
    aFb = aFb*0

    if ifbdel > 0 then
    aFb[0] delay aGrain[0], ifbdel 
    aFb[1] delay aGrain[1], ifbdel 
    else
      
    aFb = aGrain
    endif

    gaFb = gaFb + aFb*ifb      

endin

/*
    Sets the global gkEnvs based on the selecton from the GUI
*/
instr envCheck
    kcount init 0 
    kwindNum init 0     
    Schan sprintfk "envSelect_%d", kcount           
    kwindNum chnget Schan   
    gkEnvs[kcount] = gkPosibleEnvs[kwindNum-1]       
    kcount += 1
    kcount = kcount % lenarray(gkEnvs)
endin


;instr liveGrainMappers
;    
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"liveGrainAmp\" 0 1"
;    
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"intolive\" 0 1"
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"synthtolive\" 0 1"
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"sftolive\" 0 1"
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"outtolive\" 0 1"
;    
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"liverate\" 0.25 500"
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"liverateRandom\" 0 1"
;    
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"livedelay\" 0 1"
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"livedelayRandom\" 0 1"
;    
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"livegrainSize\" .005 5"
;;    scoreline_i "i \"liveGrainMap\" 0 9999 \"livegrainSize\" 50 500"
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"livegrainSizeRandom\" 0 1"
;    
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"livetranspose\" -24 24"
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"livetransposeRandom\" 0 12"
;    
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"livewindowPos\" 0 1"
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"livewindowPosRandom\" 0 1"
;    
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"liveloopSize\" .5 20"
;;    scoreline_i "i \"liveGrainMap\" 0 9999 \"liveloopSize\" 500 20000"
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"liveoverdub\" 0 1"
;    
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"livefeedback\" 0 1"
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"livefeedbackRand\" 0 1"
;    
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"livefeedbackdelay\" .001 2.5"
;;    scoreline_i "i \"liveGrainMap\" 0 9999 \"livefeedbackdelay\" 1 500"
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"livefeedbackdelayRand\" 0 1"
;    
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"livepanCenter\" 0 1"
;    scoreline_i "i \"liveGrainMap\" 0 9999 \"livepanRandom\" 0 1"
;
;endin
;
;instr liveGrainMap
;    Sname = p4  
;    iMin = p5 
;    iMax = p6  
;    Smap = sprintf("map%s", Sname)
;    Smapx = sprintf("%sx", Smap)
;    kdatachange = changed:k(gkdata1)
;    kMap chnget Smap
;    kMapx chnget Smapx 
;    //printk2(gkdata1)
;    if kMap==1 then 
;        if kdatachange == 1 then        
;         chnset k(0), Smap
;         reinit SETMAPPING
;       endif
;
;    elseif kMapx == 1 then 
;        SETMAPPING:
;        ichan = i(gkchan)
;        idata1 = i(gkdata1)
;           kval ctrl7 ichan, idata1, iMin, iMax
;           chnset kval, Sname
;        rireturn
;    
;    endif
;
;endin

//# GUI Controls
instr 55 ;GUI control for Dynamic Filter CF Offset vs. Base
kLLPcfset chnget "LLPcfset"
if changed(kLLPcfset)==1 then
  if kLLPcfset==1 then 
  chnset "visible(1)", "LLPoffset"
  chnset "visible(1)", "offsetlabel"
  chnset "visible(0)", "LLPbase"
  chnset "visible(0)", "baselabel"
  elseif kLLPcfset==2 then
  chnset "visible(0)", "LLPoffset"
  chnset "visible(0)", "offsetlabel"
  chnset "visible(1)", "LLPbase"
  chnset "visible(1)", "baselabel"
  endif
endif
endin

instr 60 ;vocal filter preset controller
 gkvpreset	chnget	"vpresets"
 ktrig		changed	gkvpreset 

 #define SET_PRESET(N'set1'set2'set3'set4'set5'set6'set7'set8'set9'set10'set11'set12'set13'set14'set15'set16)
 #
 if i(gkvpreset)==$N then
  chnset	$set1,"parsel1"	  
  chnset	$set2,"parsel2"    
  chnset	$set3,"parsel3"   
  chnset	$set4,"parsel4"
  chnset	$set5,"parF1"
  chnset	$set6,"parF2"  
  chnset	$set7,"parF3"
  chnset	$set8,"parF4"
  chnset	$set9,"parres1"
  chnset	$set10,"parres2"
  chnset	$set11,"parres3"   
  chnset	$set12,"parres4"   
  chnset	$set13,"paramp1" 
  chnset	$set14,"paramp2" 
  chnset	$set15,"paramp3"
  chnset	$set16,"paramp4"

 endif
 #
 if ktrig==1 then
  reinit SEND_PRESET
 endif
 SEND_PRESET: ;1-21=default, Sop a,e,i,o,u, Alto a,e,i,o,u, Tenor a,e,i,o,u, and Bass a,e,i,o,u
 ;           N'set1'set2'set3'set4'set5'set6'set7'set8'set9'set10'set11'set12'set13'set14'set15'set16
 $SET_PRESET(1'1'2'2'3'8'9'10'11'1'1'1'1'1'1'1'1)
 $SET_PRESET(2'2'2'2'2'octmidinn(79.4)'octmidinn(85.6)'octmidinn(101.6)'octmidinn(106.85)'800/80'1150/120'2900/200'3900/130'ampdbfs(0)'ampdbfs(-6)'ampdbfs(-32)'ampdbfs(-20)) ;soprano
 $SET_PRESET(3'2'2'2'2'octmidinn(65)'octmidinn(95.2)'octmidinn(101.1)'octmidinn(105.45)'350/60'2000/100'2800/120'3600/150'ampdbfs(0)'ampdbfs(-20)'ampdbfs(-15)'ampdbfs(-40))
 $SET_PRESET(4'2'2'2'2'octmidinn(60.6)'octmidinn(96.4)'octmidinn(101.9)'octmidinn(106.85)'270/60'2140/90'2950/100'3900/120'ampdbfs(0)'ampdbfs(-12)'ampdbfs(-26)'ampdbfs(-26))
 $SET_PRESET(5'2'2'2'2'octmidinn(69.4)'octmidinn(79.4)'octmidinn(101.2)'octmidinn(106.4)'450/40'800/80'2830/100'3800/120'ampdbfs(0)'ampdbfs(-11)'ampdbfs(-22)'ampdbfs(-22))
 $SET_PRESET(6'2'2'2'2'octmidinn(63.75)'octmidinn(77)'octmidinn(100.45)'octmidinn(106.4)'325/50'700/60'2700/170'3800/180'ampdbfs(0)'ampdbfs(-16)'ampdbfs(-35)'ampdbfs(-40))
 $SET_PRESET(7'2'2'2'2'octmidinn(79.4)'octmidinn(85.6)'octmidinn(101.1)'octmidinn(104.9)'800/80'1150/90'2800/120'3500/130'ampdbfs(0)'ampdbfs(-4)'ampdbfs(-20)'ampdbfs(-36)) ;alto
 $SET_PRESET(8'2'2'2'2'octmidinn(67.4)'octmidinn(91.4)'octmidinn(100.45)'octmidinn(103.85)'400/60'1600/80'2700/120'3300/150'ampdbfs(0)'ampdbfs(-24)'ampdbfs(-30)'ampdbfs(-35))
 $SET_PRESET(9'2'2'2'2'octmidinn(65)'octmidinn(92.4)'octmidinn(100.45)'octmidinn(105.9)'350/50'1700/100'2700/120'3700/150'ampdbfs(0)'ampdbfs(-20)'ampdbfs(-30)'ampdbfs(-36))
 $SET_PRESET(10'2'2'2'2'octmidinn(69.4)'octmidinn(79.4)'octmidinn(101.2)'octmidinn(104.9)'450/70'800/80'2830/100'3500/130'ampdbfs(0)'ampdbfs(-9)'ampdbfs(-16)'ampdbfs(-28))
 $SET_PRESET(11'2'2'2'2'octmidinn(63.75)'octmidinn(77)'octmidinn(99.3)'octmidinn(104.9)'325/50'700/60'2530/170'3500/180'ampdbfs(0)'ampdbfs(-12)'ampdbfs(-30)'ampdbfs(-40))
 $SET_PRESET(12'2'2'2'2'octmidinn(75.75)'octmidinn(84.6)'octmidinn(100.1)'octmidinn(101.6)'650/80'1080/90'2650/120'2900/130'ampdbfs(0)'ampdbfs(-6)'ampdbfs(-7)'ampdbfs(-8)) ;tenor
 $SET_PRESET(13'2'2'2'2'octmidinn(67.4)'octmidinn(92.4)'octmidinn(99.7)'octmidinn(103.4)'400/70'1700/80'2600/100'3200/120'ampdbfs(0)'ampdbfs(-14)'ampdbfs(-12)'ampdbfs(-14))
 $SET_PRESET(14'2'2'2'2'octmidinn(61.66)'octmidinn(94.1)'octmidinn(101.1)'octmidinn(103.6)'290/40'1870/90'2800/100'3250/120'ampdbfs(0)'ampdbfs(-15)'ampdbfs(-18)'ampdbfs(-20))
 $SET_PRESET(15'2'2'2'2'octmidinn(67.4)'octmidinn(79.4)'octmidinn(99.7)'octmidinn(101.1)'400/70'800/80'2600/100'2800/130'ampdbfs(0)'ampdbfs(-10)'ampdbfs(-12)'ampdbfs(-12))
 $SET_PRESET(16'2'2'2'2'octmidinn(65)'octmidinn(74.3)'octmidinn(100.45)'octmidinn(101.6)'350/40'600/60'2700/100'2900/120'ampdbfs(0)'ampdbfs(-20)'ampdbfs(-17)'ampdbfs(-14))
 $SET_PRESET(17'2'2'2'2'octmidinn(74.3)'octmidinn(83.9)'octmidinn(97.2)'octmidinn(98.6)'600/60'1040/70'2250/110'2450/120'ampdbfs(0)'ampdbfs(-7)'ampdbfs(-9)'ampdbfs(-9)) ;bass
 $SET_PRESET(18'2'2'2'2'octmidinn(67.4)'octmidinn(91.6)'octmidinn(98.4)'octmidinn(101.1)'400/40'1620/80'2400/100'2800/120'ampdbfs(0)'ampdbfs(-12)'ampdbfs(-9)'ampdbfs(-12))
 $SET_PRESET(19'2'2'2'2'octmidinn(59.33)'octmidinn(92.9)'octmidinn(99.7)'octmidinn(102.5)'250/60'1750/90'2600/100'3050/120'ampdbfs(0)'ampdbfs(-30)'ampdbfs(-16)'ampdbfs(-22))
 $SET_PRESET(20'2'2'2'2'octmidinn(67.4)'octmidinn(78.25)'octmidinn(98.4)'octmidinn(99.7)'400/40'750/80'2400/100'2600/120'ampdbfs(0)'ampdbfs(-11)'ampdbfs(-21)'ampdbfs(-20))
 $SET_PRESET(21'2'2'2'2'octmidinn(65)'octmidinn(74.3)'octmidinn(98.4)'octmidinn(100.3)'350/40'600/80'2400/100'2675/120'ampdbfs(0)'ampdbfs(-20)'ampdbfs(-32)'ampdbfs(-28))

endin

instr 61 ;Transposer preset controller
 gkTpreset	chnget	"Tpresets"
 ktrig		changed	gkTpreset 

 #define SET_PRESET(N'set1'set2'set3'set4'set5'set6'set7'set8'set9'set10'set11'set12)
 #
 if i(gkTpreset)==$N then
  chnset	$set1,"harmon1C"	  
  chnset	$set2,"harmon1F"    
  chnset	$set3,"harmon2C"   
  chnset	$set4,"harmon2F"
  chnset	$set5,"harmon3C"
  chnset	$set6,"harmon3F"  
  chnset	$set7,"harmon4C"
  chnset	$set8,"harmon4F"
  chnset	$set9,"harmon5C"
  chnset	$set10,"harmon5F"
  chnset	$set11,"harmon6C"   
  chnset	$set12,"harmon6F"
 endif
 #
 if ktrig==1 then
  reinit SEND_PRESET
 endif
 SEND_PRESET:
 ;           N'set1'set2'set3'set4'set5'set6'set7'set8'set9'set10'set11'set12'set13'set14'set15'set16
 $SET_PRESET(1'0'.14'0'-.16'0'.09'0'-.12'0'.11'0'-.05)
 $SET_PRESET(2'0'.15'0'-.16'0'.18'0'-.25'0'.24'0'-.21)
 $SET_PRESET(3'0'-.32'0'.67'0'-.65'-1'.01'1'-.06'0'.34)
 $SET_PRESET(4'7'-.05'7'.1'7'-.08'7'.01'7'-.06'7'.03)
 $SET_PRESET(5'5'.05'5'-.1'5'.08'5'-.03'5'.06'5'-.05)
 $SET_PRESET(6'4'-.07'4'.04'4'-.02'4'.06'4'-.08'4'.09)
 $SET_PRESET(7'3'.05'3'.11'3'.08'3'-.01'3'-.06'3'-.09)
 $SET_PRESET(8'0'.5'0'-.5'1'0'-1'.01'1'-.51'-1'.53)
 $SET_PRESET(9'-1'-.05'1'.1'-2'-.08'2'.01'-3'-.06'3'.03)
 $SET_PRESET(10'4'-.05'-4'.1'6'-.08'-6'.01'2'-.06'-2'.03)
 $SET_PRESET(11'21'-.05'-21'.1'7'-.08'-7'.01'14'-.06'-14'.03)
 $SET_PRESET(12'-10'-.05'10'.1'-15'-.08'15'.01'-5'-.06'5'.03)
 $SET_PRESET(13'4'-.05'-4'.1'12'-.08'-12'.01'8'-.06'-8'.03)
 $SET_PRESET(14'-9'-.05'9'.1'-6'-.08'6'.01'-3'-.06'3'.03)
 $SET_PRESET(15'-12'-.15'-24'.19'-12'-.18'24'.17'12'-.16'12'.13)
 $SET_PRESET(16'-12'-.05'-5'.1'-12'-.08'-5'.01'7'-.06'12'.03)
 $SET_PRESET(17'16'-.05'-12'.1'7'-.08'-5'.01'12'-.06'-12'.03)
 $SET_PRESET(18'12'-.05'-5'.1'3'-.08'-12'.01'7'-.06'15'.03)
 $SET_PRESET(19'4'-.05'12'.1'10'-.08'-12'.01'-5'-.06'10'.03)
 $SET_PRESET(20'7'-.05'-12'.1'-5'-.08'11'.01'4'-.06'12'.03)
 $SET_PRESET(21'11'-.05'4'.1'12'-.08'2'.01'-12'-.06'-5'.03)
 $SET_PRESET(22'10'-.05'12'.1'7'-.08'3'.01'-5'-.06'-12'.03)
 $SET_PRESET(23'-12'-.05'-5'.1'5'-.08'7'.01'0'-.06'12'.03)
 $SET_PRESET(24'7'-.05'10'.1'12'-.08'-12'.01'-5'-.06'5'.03)
 $SET_PRESET(25'12'-.05'10'.1'-12'-.08'-5'.01'4'-.06'15'.03)
 $SET_PRESET(26'10'-.05'-12'.1'12'-.08'4'.01'-5'-.06'14'.03)
 $SET_PRESET(27'0'-.05'4'.1'-12'-.08'10'.01'15'-.06'4'.03)

endin

//#MIDI Stuff

instr 100   ;instrument to monitor MIDI controller numbers, creates global MIDI outputs that are evaluated by instr 110-300         
            ;also controls popup for latched LowPass and soundfile string management
gkstatus,gkchan,gkdata1,gkdata2 midiin
if changed(gkstatus)==1 then  
    if gkstatus==176 then
    chnset gkdata1,"CtrlNum" ;displays current controller number in GUI
    endif
endif
endin

instr 101 ;master volume MIDI mapping
kmapMamp chnget "mapMamp"
kmapMampX chnget "mapMampX"
if changed(gkstatus)==1 then
  if gkstatus==176 then
    if kmapMamp==1 then
      turnoff2 102,2,0
      event "i",102,0,999999999
    endif
  endif
endif
if kmapMampX==1 then
  turnoff2 102,2,0
endif
endin

instr 102
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1.5000 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "MAmp"
endin

instr 103 ;pitch ribbon MIDI mapping
kmaprib chnget "maprib"
kmapribX chnget "mapribX"
if changed(gkstatus)==1 then
  if gkstatus==176 then
    if kmaprib==1 then
      turnoff2 104,2,0
      event "i",104,0,999999999
    endif
  endif
endif
if kmapribX==1 then
  turnoff2 104,2,0
endif
endin

instr 104
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-36,36 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "ribbon"
endin

instr 105 ;Live Audio Amp MIDI mapping
kmapliveamp chnget "mapliveamp"
kmapliveampX chnget "mapliveampX"
if changed(gkstatus)==1 then
  if gkstatus==176 then
    if kmapliveamp==1 then
      turnoff2 106,2,0
      event "i",106,0,999999999
    endif
  endif
endif
if kmapliveampX==1 then
  turnoff2 106,2,0
endif
endin

instr 106
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,2.5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "liveamp"
endin

instr 110 ;MIDI mapping for keyboard ADSR
kmapA chnget "mapA"
kmapAX chnget "mapAX"
kmapD chnget "mapD"
kmapDX chnget "mapDX"
kmapS chnget "mapS"
kmapSX chnget "mapSX"
kmapR chnget "mapR"
kmapRX chnget "mapRX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapA == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 111, 2, 0
            event "i", 111, 0, 999999999
        elseif kmapD == 1 then
            turnoff2 112, 2, 0
            event "i", 112, 0, 999999999
        elseif kmapS == 1 then
            turnoff2 113, 2, 0
            event "i", 113, 0, 999999999
        elseif kmapR == 1 then
            turnoff2 114, 2, 0
            event "i", 114, 0, 999999999
        endif
    endif
endif

if kmapAX == 1 then ;release from controller
    turnoff2 111, 2, 0
elseif kmapDX == 1 then
    turnoff2 112, 2, 0
elseif kmapSX == 1 then
    turnoff2 113, 2, 0
elseif kmapRX == 1 then
    turnoff2 114, 2, 0
endif
endin

instr 111
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "A"
endin

instr 112
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "D"
endin

instr 113
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "S"
endin

instr 114
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "R"
endin

instr 120
kmaprate chnget "maprate"
kmaprateX chnget "maprateX"
kmardev chnget "maprdev"
kmaprdevX chnget "maprdevX"
kmapbasedur chnget "mapbasedur"
kmapbasedurX chnget "mapbasedurX"
kmapdurdev chnget "mapdurdev"
kmapdurdevX chnget "mapdurdevX"
kmappan chnget "mappan"
kmappanX chnget "mappanX"
kmapspread chnget "mapspread"
kmapspreadX chnget "mapspreadX"
kmapatt chnget "mapatt"
kmapattX chnget "mapattX"
kmacpsdev chnget "mapcpsdev"
kmapcpsdevX chnget "mapcpsdevX"
kmapampdev chnget "mapampdev"
kmapampdevX chnget "mapampdevX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmaprate == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 121, 2, 0
            event "i", 121, 0, 999999999
        elseif kmardev == 1 then
            turnoff2 122, 2, 0
            event "i", 122, 0, 999999999
        elseif kmapbasedur == 1 then
            turnoff2 123, 2, 0
            event "i", 123, 0, 999999999
        elseif kmapdurdev == 1 then
            turnoff2 124, 2, 0
            event "i", 124, 0, 999999999
        elseif kmappan == 1 then
            turnoff2 125, 2, 0
            event "i", 125, 0, 999999999
        elseif kmapspread == 1 then
            turnoff2 126, 2, 0
            event "i", 126, 0, 999999999
        elseif kmapatt == 1 then
            turnoff2 127, 2, 0
            event "i", 127, 0, 999999999
        elseif kmacpsdev == 1 then
            turnoff2 128, 2, 0
            event "i", 128, 0, 999999999
        elseif kmapampdev == 1 then
            turnoff2 129, 2, 0
            event "i", 129, 0, 999999999
        endif
    endif
endif

if kmaprateX == 1 then ;release from controller
    turnoff2 121, 2, 0
elseif kmaprdevX == 1 then
    turnoff2 122, 2, 0
elseif kmapbasedurX == 1 then
    turnoff2 123, 2, 0
elseif kmapdurdevX == 1 then
    turnoff2 124, 2, 0
elseif kmappanX == 1 then
    turnoff2 125, 2, 0
elseif kmapspreadX == 1 then
    turnoff2 126, 2, 0
elseif kmapattX == 1 then
    turnoff2 127, 2, 0
elseif kmapcpsdevX == 1 then
    turnoff2 128, 2, 0
elseif kmapampdevX == 1 then
    turnoff2 129, 2, 0
endif
endin
 
instr 121
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.25,500 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "rate"
endin

instr 122
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "rdev"
endin

instr 123
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.005,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "basedur"
endin

instr 124
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "durdev"
endin

instr 125
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "pan"
endin

instr 126
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "spread"
endin

instr 127
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,.49 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "att"
endin

instr 128
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "cpsdev"
endin

instr 129
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "ampdev"
endin

instr 130 ;FM ratio MIDI controllers
kmaprat1 chnget "maprat1"
kmaprat1X chnget "maprat1X"
kmaprat2 chnget "maprat2"
kmaprat2X chnget "maprat2X"
kmapfmA chnget "mapfmA"
kmapfmAX chnget "mapfmAX"
kmapfmD chnget "mapfmD"
kmapfmDX chnget "mapfmDX"
kmapfmS chnget "mapfmS"
kmapfmSX chnget "mapfmSX"
kmapfmR chnget "mapfmR"
kmapfmRX chnget "mapfmRX"
kmapmodrand chnget "mapmodrand"
kmapmodrandX chnget "mapmodrandX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmaprat1 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 131, 2, 0
            event "i", 131, 0, 999999999
        elseif kmaprat2 == 1 then
            turnoff2 132, 2, 0
            event "i", 132, 0, 999999999
        elseif kmapfmA == 1 then
            turnoff2 133, 2, 0
            event "i", 133, 0, 999999999
        elseif kmapfmD == 1 then
            turnoff2 134, 2, 0
            event "i", 134, 0, 999999999
        elseif kmapfmS == 1 then
            turnoff2 135, 2, 0
            event "i", 135, 0, 999999999
        elseif kmapfmR == 1 then
            turnoff2 136, 2, 0
            event "i", 136, 0, 999999999
        elseif kmapmodrand == 1 then
            turnoff2 137, 2, 0
            event "i", 137, 0, 999999999
        endif
    endif
endif

if kmaprat1X == 1 then ;release from controller
    turnoff2 131, 2, 0
elseif kmaprat2X == 1 then
    turnoff2 132, 2, 0
elseif kmapfmAX == 1 then
    turnoff2 133, 2, 0
elseif kmapfmDX == 1 then
    turnoff2 134, 2, 0
elseif kmapfmSX == 1 then
    turnoff2 135, 2, 0
elseif kmapfmRX == 1 then
    turnoff2 136, 2, 0
elseif kmapmodrandX == 1 then
    turnoff2 137, 2, 0
endif
endin
 
instr 131
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.25,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "rat1"
endin

instr 132
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.25,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "rat2"
endin

instr 133
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "fmA"
endin

instr 134
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "fmD"
endin

instr 135
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "fmS"
endin

instr 136
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "fmR"
endin

instr 137
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "modrand"
endin

instr 140 ;FM index MIDI controllers
kmapind1 chnget "mapind1"
kmapind1X chnget "mapind1X"
kmapind2 chnget "mapind2"
kmapind2X chnget "mapind2X"
kmapindA chnget "mapindA"
kmapindAX chnget "mapindAX"
kmapindD chnget "mapindD"
kmapindDX chnget "mapindDX"
kmapindS chnget "mapindS"
kmapindSX chnget "mapindSX"
kmapindR chnget "mapindR"
kmapindRX chnget "mapindRX"
kmapindexrand chnget "mapindexrand"
kmapindexrandX chnget "mapindexrandX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapind1 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 141, 2, 0
            event "i", 141, 0, 999999999
        elseif kmapind2 == 1 then
            turnoff2 142, 2, 0
            event "i", 142, 0, 999999999
        elseif kmapindA == 1 then
            turnoff2 143, 2, 0
            event "i", 143, 0, 999999999
        elseif kmapindD == 1 then
            turnoff2 144, 2, 0
            event "i", 144, 0, 999999999
        elseif kmapindS == 1 then
            turnoff2 145, 2, 0
            event "i", 145, 0, 999999999
        elseif kmapindR == 1 then
            turnoff2 146, 2, 0
            event "i", 146, 0, 999999999
        elseif kmapindexrand == 1 then
            turnoff2 147, 2, 0
            event "i", 147, 0, 999999999
        endif
    endif
endif

if kmapind1X == 1 then ;release from controller
    turnoff2 141, 2, 0
elseif kmapind2X == 1 then
    turnoff2 142, 2, 0
elseif kmapindAX == 1 then
    turnoff2 143, 2, 0
elseif kmapindDX == 1 then
    turnoff2 144, 2, 0
elseif kmapindSX == 1 then
    turnoff2 145, 2, 0
elseif kmapindRX == 1 then
    turnoff2 146, 2, 0
elseif kmapindexrandX == 1 then
    turnoff2 147, 2, 0
endif
endin
 
instr 141
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,1,99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "ind1"
endin

instr 142
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,1,99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "ind2"
endin

instr 143
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "indA"
endin

instr 144
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "indD"
endin

instr 145
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "indS"
endin

instr 146
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "indR"
endin

instr 147
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "indexrand"
endin

instr 150 ;Live Audio MIDI controllers
kmaplived chnget "maplived"
kmaplivedX chnget "maplivedX"
kmaplivedr chnget "maplivedr"
kmaplivedrX chnget "maplivedrX"
kmapliveT chnget "mapliveT"
kmapliveTX chnget "mapliveTX"
kmapliveTr chnget "mapliveTr"
kmapliveTrX chnget "mapliveTrX"
kmapliveFB chnget "mapliveFB"
kmapliveFBX chnget "mapliveFBX"
kmapliveFBd chnget "mapliveFBd"
kmapliveFBdX chnget "mapliveFBdX"
kmapliveFBdr chnget "mapliveFBdr"
kmapliveFBdrX chnget "mapliveFBdrX"
kmaplivegrmix chnget "maplivegrmix"
kmaplivegrmixX chnget "maplivegrmixX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmaplived == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 151, 2, 0
            event "i", 151, 0, 999999999
        elseif kmaplivedr == 1 then
            turnoff2 152, 2, 0
            event "i", 152, 0, 999999999
        elseif kmapliveT == 1 then
            turnoff2 153, 2, 0
            event "i", 153, 0, 999999999
        elseif kmapliveTr == 1 then
            turnoff2 154, 2, 0
            event "i", 154, 0, 999999999
        elseif kmapliveFB == 1 then
            turnoff2 155, 2, 0
            event "i", 155, 0, 999999999
        elseif kmapliveFBd == 1 then
            turnoff2 156, 2, 0
            event "i", 156, 0, 999999999
        elseif kmapliveFBdr == 1 then
            turnoff2 157, 2, 0
            event "i", 157, 0, 999999999
        elseif kmaplivegrmix == 1 then
            turnoff2 158, 2, 0
            event "i", 158, 0, 999999999
        endif
    endif
endif

if kmaplivedX == 1 then ;release from controller
    turnoff2 151, 2, 0
elseif kmaplivedrX == 1 then
    turnoff2 152, 2, 0
elseif kmapliveTX == 1 then
    turnoff2 153, 2, 0
elseif kmapliveTrX == 1 then
    turnoff2 154, 2, 0
elseif kmapliveFBX == 1 then
    turnoff2 155, 2, 0
elseif kmapliveFBdX == 1 then
    turnoff2 156, 2, 0
elseif kmapliveFBdrX == 1 then
    turnoff2 157, 2, 0
elseif kmaplivegrmixX == 1 then
    turnoff2 158, 2, 0
endif
endin
 
instr 151
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "lived"
endin

instr 152
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "livedr"
endin

instr 153
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "liveT"
endin

instr 154
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "liveTr"
endin

instr 155
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "liveFB"
endin

instr 156
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "liveFBd"
endin

instr 157
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "liveFBdr"
endin

instr 158
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "livegrmix"
endin

instr 160 ;SF Granulator MIDI controllers
kmapsfamp chnget "mapsfamp"
kmapsfampX chnget "mapsfampX"
kmapscrub chnget "mapscrub"
kmapscrubX chnget "mapscrubX"
kmapscrubr chnget "mapscrubr"
kmapscrubrX chnget "mapscrubrX"
kmapscrubT chnget "mapscrubT"
kmapscrubTX chnget "mapscrubTX"
kmapscrubTr chnget "mapscrubTr"
kmapscrubTrX chnget "mapscrubTrX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapsfamp == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 161, 2, 0
            event "i", 161, 0, 999999999
        elseif kmapscrub == 1 then
            turnoff2 162, 2, 0
            event "i", 162, 0, 999999999
        elseif kmapscrubr == 1 then
            turnoff2 163, 2, 0
            event "i", 163, 0, 999999999
        elseif kmapscrubT == 1 then
            turnoff2 164, 2, 0
            event "i", 164, 0, 999999999
        elseif kmapscrubTr == 1 then
            turnoff2 165, 2, 0
            event "i", 165, 0, 999999999
        endif
    endif
endif

if kmapsfampX == 1 then ;release from controller
    turnoff2 161, 2, 0
elseif kmapscrubX == 1 then
    turnoff2 162, 2, 0
elseif kmapscrubrX == 1 then
    turnoff2 163, 2, 0
elseif kmapscrubTX == 1 then
    turnoff2 164, 2, 0
elseif kmapscrubTrX == 1 then
    turnoff2 165, 2, 0
endif
endin
 
instr 161
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "sfamp"
endin

instr 162
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "scrub"
endin

instr 163
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "scrubr"
endin

instr 164
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-48,48 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "scrubT"
endin

instr 165
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,36 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "scrubTr"
endin

instr 170 ;MIDI mapping for synth amps and noise
kmapanalogamp chnget "mapanalogamp"
kmapanalogampX chnget "mapanalogampX"
kmapnzamp chnget "mapnzamp"
kmapnzampX chnget "mapnzampX"
kmapwaveamp chnget "mapwaveamp"
kmapwaveampX chnget "mapwaveampX"
kmapfmamp chnget "mapfmamp"
kmapfmampX chnget "mapfmampX"
kmapnzfiltF1 chnget "mapnzfiltF1"
kmapnzfiltF1X chnget "mapnzfiltF1X"
kmapnzfiltF2 chnget "mapnzfiltF2"
kmapnzfiltF2X chnget "mapnzfiltF2X"
kmapnzfiltQ1 chnget "mapnzfiltQ1"
kmapnzfiltQ1X chnget "mapnzfiltQ1X"
kmapnzfiltQ2 chnget "mapnzfiltQ2"
kmapnzfiltQ2X chnget "mapnzfiltQ2X"

if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapanalogamp == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 171, 2, 0
            event "i", 171, 0, 999999999
        elseif kmapnzamp == 1 then
            turnoff2 172, 2, 0
            event "i", 172, 0, 999999999
        elseif kmapwaveamp == 1 then
            turnoff2 173, 2, 0
            event "i", 173, 0, 999999999
        elseif kmapfmamp == 1 then
            turnoff2 174, 2, 0
            event "i", 174, 0, 999999999
        elseif kmapnzfiltF1 == 1 then
            turnoff2 175, 2, 0
            event "i", 175, 0, 999999999
        elseif kmapnzfiltF2 == 1 then
            turnoff2 176, 2, 0
            event "i", 176, 0, 999999999
        elseif kmapnzfiltQ1 == 1 then
            turnoff2 177, 2, 0
            event "i", 177, 0, 999999999
        elseif kmapnzfiltQ2 == 1 then
            turnoff2 178, 2, 0
            event "i", 178, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapanalogampX == 1 then
    turnoff2 171, 2, 0
elseif kmapnzampX == 1 then
    turnoff2 172, 2, 0
elseif kmapwaveampX == 1 then
    turnoff2 173, 2, 0
elseif kmapfmampX == 1 then
    turnoff2 174, 2, 0
elseif kmapnzfiltF1X == 1 then
    turnoff2 175, 2, 0
elseif kmapnzfiltF2X == 1 then
    turnoff2 176, 2, 0
elseif kmapnzfiltQ1X == 1 then
    turnoff2 177, 2, 0
elseif kmapnzfiltQ2X == 1 then
    turnoff2 178, 2, 0
endif
endin

instr 171 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,2 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "analogamp"
endin

instr 172 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,2 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "nzamp"
endin

instr 173 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,2 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "waveamp"
endin

instr 174 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,2 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "fmamp"
endin

instr 175 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,20,20000 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "nzfiltF1"
endin

instr 176 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,20,20000 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "nzfiltF2"
endin

instr 177 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.5,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "nzfiltQ1"
endin

instr 178 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.5,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "nzfiltQ2"
endin

instr 200
;receive MIDI mapping buttons for RNG and non-key activated grain stream
kmapRNGrate chnget "mapRNGrate"
kmapRNGrateX chnget "mapRNGrateX"
kmapRNGraterand chnget "mapRNGraterand"
kmapRNGraterandX chnget "mapRNGraterandX"
kmapRNGdev chnget "mapRNGdev"
kmapRNGdevX chnget "mapRNGdevX"
kmapgrainstreamnote chnget "mapgrainstreamnote"
kmapgrainstreamnoteX chnget "mapgrainstreamnoteX"
kmapgrainstreamamp chnget "mapgrainstreamamp"
kmapgrainstreamampX chnget "mapgrainstreamampX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapRNGrate == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 201, 2, 0
            event "i", 201, 0, 999999999
        elseif kmapRNGraterand == 1 then
            turnoff2 202, 2, 0
            event "i", 202, 0, 999999999
        elseif kmapRNGdev == 1 then
            turnoff2 204, 2, 0
            event "i", 204, 0, 999999999
        elseif kmapgrainstreamnote == 1 then
            turnoff2 205, 2, 0
            event "i", 205, 0, 999999999
        elseif kmapgrainstreamamp == 1 then
            turnoff2 206, 2, 0
            event "i", 206, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapRNGrateX == 1 then
    turnoff2 201, 2, 0
elseif kmapRNGraterandX == 1 then
    turnoff2 202, 2, 0
elseif kmapRNGdevX == 1 then
    turnoff2 204, 2, 0
elseif kmapgrainstreamnoteX == 1 then
    turnoff2 205, 2, 0
elseif kmapgrainstreamampX == 1 then
    turnoff2 206, 2, 0
endif
endin

instr 201 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "RNGrate"
endin

instr 202 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "RNGraterand"
endin

instr 204 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,60 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "RNGdev"
endin

instr 205 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,20,127 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "grainstreamnote"
endin

instr 206 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "grainstreamamp"
endin

instr 210
;receive MIDI mapping buttons for Distortion
kmapdist chnget "mapdist"
kmapdistX chnget "mapdistX"
kmapdist2 chnget "mapdist2"
kmapdist2X chnget "mapdist2X"
kmapdist3 chnget "mapdist3"
kmapdist3X chnget "mapdist3X"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapdist == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 211, 2, 0
            event "i", 211, 0, 999999999
        elseif kmapdist2 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 212, 2, 0
            event "i", 212, 0, 999999999
        elseif kmapdist3 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 213, 2, 0
            event "i", 213, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapdistX == 1 then
    turnoff2 211, 2, 0
elseif kmapdist2X == 1 then
    turnoff2 212, 2, 0
elseif kmapdist3X == 1 then
    turnoff2 213, 2, 0
endif
endin

instr 211 ;MIDI mapping for Distortion
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "dist"
endin

instr 212 ;MIDI mapping for Distortion
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.999 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "dist2"
endin

instr 213 ;MIDI mapping for Distortion
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,1,25 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "dist3"
endin

instr 220
;receive MIDI mapping buttons for Vibrato
kmapvibrand chnget "mapvibrand"
kmapvibrandX chnget "mapvibrandX"
kmapvibcps chnget "mapvibcps"
kmapvibcpsX chnget "mapvibcpsX"
kmapvibdepth chnget "mapvibdepth"
kmapvibdepthX chnget "mapvibdepthX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapvibrand == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 221, 2, 0
            event "i", 221, 0, 999999999
        elseif kmapvibcps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 222, 2, 0
            event "i", 222, 0, 999999999
        elseif kmapvibdepth == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 223, 2, 0
            event "i", 223, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapvibrandX == 1 then
    turnoff2 221, 2, 0
elseif kmapvibcpsX == 1 then
    turnoff2 222, 2, 0
elseif kmapvibdepthX == 1 then
    turnoff2 223, 2, 0
endif
endin

instr 221 ;MIDI mapping for Vibrato
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "vibrand"
endin

instr 222 ;MIDI mapping for Vibrato
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "vibcps"
endin

instr 223 ;MIDI mapping for Vibrato
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "vibdepth"
endin

instr 230
;receive MIDI mapping buttons for Lowpass
kmapLPcps chnget "mapLPcps"
kmapLPcpsX chnget "mapLPcpsX"
kmapLPres chnget "mapLPres"
kmapLPresX chnget "mapLPresX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapLPcps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 231, 2, 0
            event "i", 231, 0, 999999999
        elseif kmapLPres == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 232, 2, 0
            event "i", 232, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapLPcpsX == 1 then
    turnoff2 231, 2, 0
elseif kmapLPresX == 1 then
    turnoff2 232, 2, 0
endif
endin

instr 231 ;MIDI mapping for Lowpass
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,100,15000 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "LPcps"
endin

instr 232 ;MIDI mapping for Lowpass
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "LPres"
endin

instr 240
;receive MIDI mapping buttons for Phaser
kmapphscps chnget "mapphscps"
kmapphscpsX chnget "mapphscpsX"
kmapphsFB chnget "mapphsFB"
kmapphsFBX chnget "mapphsFBX"
kmapphsQ chnget "mapphsQ"
kmapphsQX chnget "mapphsQX"


;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapphscps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 241, 2, 0
            event "i", 241, 0, 999999999
        elseif kmapphsFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 242, 2, 0
            event "i", 242, 0, 999999999
        elseif kmapphsQ == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 243, 2, 0
            event "i", 243, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapphscpsX == 1 then
    turnoff2 241, 2, 0
elseif kmapphsFBX == 1 then
    turnoff2 242, 2, 0
elseif kmapphsQX == 1 then
    turnoff2 243, 2, 0
endif
endin

instr 241 ;MIDI mapping for Phaser
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "phscps"
endin

instr 242 ;MIDI mapping for Phaser
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "phsFB"
endin

instr 243 ;MIDI mapping for Phaser
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "phsQ"
endin

instr 250
;receive MIDI mapping buttons for Flanger
kmapflcps chnget "mapflcps"
kmapflcpsX chnget "mapflcpsX"
kmapflFB chnget "mapflFB"
kmapflFBX chnget "mapflFBX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapflcps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 251, 2, 0
            event "i", 251, 0, 999999999
        elseif kmapflFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 252, 2, 0
            event "i", 252, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapflcpsX == 1 then
    turnoff2 251, 2, 0
elseif kmapflFBX == 1 then
    turnoff2 252, 2, 0
endif
endin

instr 251 ;MIDI mapping for Flanger
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "flcps"
endin

instr 252 ;MIDI mapping for Flanger
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "flFB"
endin

instr 260
;receive MIDI mapping buttons for Transposer
kmapharmmix chnget "mapharmmix"
kmapharmmixX chnget "mapharmmixX"
kmapharmon1C chnget "mapharmon1C"
kmapharmon1CX chnget "mapharmon1CX"
kmapharmon1F chnget "mapharmon1F"
kmapharmon1FX chnget "mapharmon1FX"
kmapharmon2C chnget "mapharmon2C"
kmapharmon2CX chnget "mapharmon2CX"
kmapharmon2F chnget "mapharmon2F"
kmapharmon2FX chnget "mapharmon2FX"
kmapharmon3C chnget "mapharmon3C"
kmapharmon3CX chnget "mapharmon3CX"
kmapharmon3F chnget "mapharmon3F"
kmapharmon3FX chnget "mapharmon3FX"
kmapharmon4C chnget "mapharmon4C"
kmapharmon4CX chnget "mapharmon4CX"
kmapharmon4F chnget "mapharmon4F"
kmapharmon4FX chnget "mapharmon4FX"
kmapharmon5C chnget "mapharmon5C"
kmapharmon5CX chnget "mapharmon5CX"
kmapharmon5F chnget "mapharmon5F"
kmapharmon5FX chnget "mapharmon5FX"
kmapharmon6C chnget "mapharmon6C"
kmapharmon6CX chnget "mapharmon6CX"
kmapharmon6F chnget "mapharmon6F"
kmapharmon6FX chnget "mapharmon6FX"


;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapharmmix == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 261, 2, 0
            event "i", 261, 0, 999999999
        elseif kmapharmon1C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 262, 2, 0
            event "i", 262, 0, 999999999
        elseif kmapharmon1F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 263, 2, 0
            event "i", 263, 0, 999999999
        elseif kmapharmon2C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 264, 2, 0
            event "i", 264, 0, 999999999
        elseif kmapharmon2F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 265, 2, 0
            event "i", 265, 0, 999999999
        elseif kmapharmon3C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 266, 2, 0
            event "i", 266, 0, 999999999
        elseif kmapharmon3F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 267, 2, 0
            event "i", 267, 0, 999999999
        elseif kmapharmon4C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 268, 2, 0
            event "i", 268, 0, 999999999
        elseif kmapharmon4F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 269, 2, 0
            event "i", 269, 0, 999999999
        elseif kmapharmon5C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 270, 2, 0
            event "i", 270, 0, 999999999
        elseif kmapharmon5F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 271, 2, 0
            event "i", 271, 0, 999999999
        elseif kmapharmon6C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 272, 2, 0
            event "i", 272, 0, 999999999
        elseif kmapharmon6F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 273, 2, 0
            event "i", 273, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapharmmixX == 1 then
    turnoff2 261, 2, 0
elseif kmapharmon1CX == 1 then
    turnoff2 262, 2, 0
elseif kmapharmon1FX == 1 then
    turnoff2 263, 2, 0
elseif kmapharmon2CX == 1 then
    turnoff2 264, 2, 0
elseif kmapharmon2FX == 1 then
    turnoff2 265, 2, 0
elseif kmapharmon3CX == 1 then
    turnoff2 266, 2, 0
elseif kmapharmon3FX == 1 then
    turnoff2 267, 2, 0
elseif kmapharmon4CX == 1 then
    turnoff2 268, 2, 0
elseif kmapharmon4FX == 1 then
    turnoff2 269, 2, 0
elseif kmapharmon5CX == 1 then
    turnoff2 270, 2, 0
elseif kmapharmon5FX == 1 then
    turnoff2 271, 2, 0
elseif kmapharmon6CX == 1 then
    turnoff2 272, 2, 0
elseif kmapharmon6FX == 1 then
    turnoff2 273, 2, 0
endif
endin

instr 261 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmmix"
endin

instr 262 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon1C"
endin

instr 263 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon1F"
endin

instr 264 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon2C"
endin

instr 265 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon2F"
endin

instr 266 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon3C"
endin

instr 267 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon3F"
endin

instr 268 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon4C"
endin

instr 269 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon4F"
endin

instr 270 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon5C"
endin

instr 271 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon5F"
endin

instr 272 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon6C"
endin

instr 273 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon6F"
endin

instr 280
;receive MIDI mapping buttons for Chorus
kmapchmix chnget "mapchmix"
kmapchmixX chnget "mapchmixX"
kmapchcps chnget "mapchcps"
kmapchcpsX chnget "mapchcpsX"
kmapchFB chnget "mapchFB"
kmapchFBX chnget "mapchFBX"
kmapchdepth chnget "mapchdepth"
kmapchdepthX chnget "mapchdepthX"
kmapchdel chnget "mapchdel"
kmapchdelX chnget "mapchdelX"
kmapchrand chnget "mapchrand"
kmapchrandX chnget "mapchrandX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapchmix == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 281, 2, 0
            event "i", 281, 0, 999999999
        elseif kmapchcps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 282, 2, 0
            event "i", 282, 0, 999999999
        elseif kmapchFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 283, 2, 0
            event "i", 283, 0, 999999999
        elseif kmapchdepth == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 284, 2, 0
            event "i", 284, 0, 999999999
        elseif kmapchdel == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 285, 2, 0
            event "i", 285, 0, 999999999
        elseif kmapchrand == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 286, 2, 0
            event "i", 286, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapchmixX == 1 then
    turnoff2 281, 2, 0
elseif kmapchcpsX == 1 then
    turnoff2 282, 2, 0
elseif kmapchFBX == 1 then
    turnoff2 283, 2, 0
elseif kmapchdepthX == 1 then
    turnoff2 284, 2, 0
elseif kmapchdelX == 1 then
    turnoff2 285, 2, 0
elseif kmapchrandX == 1 then
    turnoff2 286, 2, 0
endif
endin

instr 281 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chmix"
endin

instr 282 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,25 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chcps"
endin

instr 283 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.999 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chFB"
endin

instr 284 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.1,50 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chdepth"
endin

instr 285 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.1,50 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chdel"
endin

instr 286 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.9 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chrand"
endin

instr 290
;receive MIDI mapping buttons for Delay
kmapdeltime chnget "mapdeltime"
kmapdeltimeX chnget "mapdeltimeX"
kmapdelFB chnget "mapdelFB"
kmapdelFBX chnget "mapdelFBX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapdeltime == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 291, 2, 0
            event "i", 291, 0, 999999999
        elseif kmapdelFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 292, 2, 0
            event "i", 292, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapdeltimeX == 1 then
    turnoff2 291, 2, 0
elseif kmapdelFBX == 1 then
    turnoff2 292, 2, 0
endif
endin

instr 291 ;MIDI mapping for Delay
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,4.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "deltime"
endin

instr 292 ;MIDI mapping for Delay
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "delFB"
endin

instr 300
;receive MIDI mapping buttons for Reverb
kmaprevmix chnget "maprevmix"
kmaprevmixX chnget "maprevmixX"
kmaprevFB chnget "maprevFB"
kmaprevFBX chnget "maprevFBX"
kmaprevLP chnget "maprevLP"
kmaprevLPX chnget "maprevLPX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmaprevmix == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 301, 2, 0
            event "i", 301, 0, 999999999
        elseif kmaprevFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 302, 2, 0
            event "i", 302, 0, 999999999
        elseif kmaprevLP == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 303, 2, 0
            event "i", 303, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmaprevmixX == 1 then
    turnoff2 301, 2, 0
elseif kmaprevFBX == 1 then
    turnoff2 302, 2, 0
elseif kmaprevLPX == 1 then
    turnoff2 303, 2, 0
endif
endin

instr 301 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "revmix"
endin

instr 302 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,.999 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "revFB"
endin

instr 303 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,200,20000 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "revLP"
endin

instr 310 ;MIDI mapping for live granulation
kmapliveGrainAmp chnget "mapliveGrainAmp"
kmapliveGrainAmpx chnget "mapliveGrainAmpx"
kmapintolive chnget "mapintolive"
kmapintolivex chnget "mapintolivex"
kmapsynthtolive chnget "mapsynthtolive"
kmapsynthtolivex chnget "mapsynthtolivex"
kmapsftolive chnget "mapsftolive"
kmapsftolivex chnget "mapsftolivex"
kmapouttolive chnget "mapouttolive"
kmapouttolivex chnget "mapouttolivex"
kmapliverate chnget "mapliverate"
kmapliveratex chnget "mapliveratex"
kmapliverateRandom chnget "mapliverateRandom"
kmapliverateRandomx chnget "mapliverateRandomx"
kmaplivetranspose chnget "maplivetranspose"
kmaplivetransposex chnget "maplivetransposex"
kmaplivetransposeRandom chnget "maplivetransposeRandom"
kmaplivetransposeRandomx chnget "maplivetransposeRandomx"
kmaplivepanCenter chnget "maplivepanCenter"
kmaplivepanCenterx chnget "maplivepanCenterx"
kmaplivepanRandom chnget "maplivepanRandom"
kmaplivepanRandomx chnget "maplivepanRandomx"
kmaplivegrainSize chnget "maplivegrainSize"
kmaplivegrainSizex chnget "maplivegrainSizex"
kmaplivegrainSizeRandom chnget "maplivegrainSizeRandom"
kmaplivegrainSizeRandomx chnget "maplivegrainSizeRandomx"
kmaplivewindowPos chnget "maplivewindowPos"
kmaplivewindowPosx chnget "maplivewindowPosx"
kmaplivewindowPosRandom chnget "maplivewindowPosRandom"
kmaplivewindowPosRandomx chnget "maplivewindowPosRandomx"
kmapliveloopSize chnget "mapliveloopSize"
kmapliveloopSizex chnget "mapliveloopSizex"
kmaplivedelay chnget "maplivedelay"
kmaplivedelayx chnget "maplivedelayx"
kmaplivedelayRandom chnget "maplivedelayRandom"
kmaplivedelayRandomx chnget "maplivedelayRandomx"
kmaplivefeedback chnget "maplivefeedback"
kmaplivefeedbackx chnget "maplivefeedbackx"
kmaplivefeedbackRand chnget "maplivefeedbackRand"
kmaplivefeedbackRandx chnget "maplivefeedbackRandx"
kmaplivefeedbackdelay chnget "maplivefeedbackdelay"
kmaplivefeedbackdelayx chnget "maplivefeedbackdelayx"
kmaplivefeedbackdelayRand chnget "maplivefeedbackdelayRand"
kmaplivefeedbackdelayRandx chnget "maplivefeedbackdelayRandx"
kmapliveoverdub chnget "mapliveoverdub"
kmapliveoverdubx chnget "mapliveoverdubx"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapliveGrainAmp == 1 then 
            turnoff2 311, 2, 0
            event "i", 311, 0, 999999999
        elseif kmapintolive == 1 then 
            turnoff2 312, 2, 0
            event "i", 312, 0, 999999999
        elseif kmapsynthtolive == 1 then 
            turnoff2 313, 2, 0
            event "i", 313, 0, 999999999
        elseif kmapsftolive == 1 then 
            turnoff2 314, 2, 0
            event "i", 314, 0, 999999999
        elseif kmapouttolive == 1 then 
            turnoff2 315, 2, 0
            event "i", 315, 0, 999999999
        elseif kmapliverate == 1 then 
            turnoff2 316, 2, 0
            event "i", 316, 0, 999999999
        elseif kmapliverateRandom == 1 then 
            turnoff2 317, 2, 0
            event "i", 317, 0, 999999999
        elseif kmaplivetranspose == 1 then 
            turnoff2 318, 2, 0
            event "i", 318, 0, 999999999
        elseif kmaplivetransposeRandom == 1 then 
            turnoff2 319, 2, 0
            event "i", 319, 0, 999999999
        elseif kmaplivepanCenter == 1 then 
            turnoff2 320, 2, 0
            event "i", 320, 0, 999999999
        elseif kmaplivepanRandom == 1 then 
            turnoff2 321, 2, 0
            event "i", 321, 0, 999999999               
        elseif kmaplivegrainSize == 1 then 
            turnoff2 322, 2, 0
            event "i", 322, 0, 999999999
        elseif kmaplivegrainSizeRandom == 1 then 
            turnoff2 323, 2, 0
            event "i", 323, 0, 999999999
        elseif kmaplivewindowPos == 1 then 
            turnoff2 324, 2, 0
            event "i", 324, 0, 999999999
        elseif kmaplivewindowPosRandom == 1 then 
            turnoff2 325, 2, 0
            event "i", 325, 0, 999999999
        elseif kmapliveloopSize == 1 then 
            turnoff2 326, 2, 0
            event "i", 326, 0, 999999999
        elseif kmaplivedelay == 1 then 
            turnoff2 327, 2, 0
            event "i", 327, 0, 999999999
        elseif kmaplivedelayRandom == 1 then 
            turnoff2 328, 2, 0
            event "i", 328, 0, 999999999
        elseif kmaplivefeedback == 1 then 
            turnoff2 329, 2, 0
            event "i", 329, 0, 999999999
        elseif kmaplivefeedbackRand == 1 then 
            turnoff2 330, 2, 0
            event "i", 330, 0, 999999999
        elseif kmaplivefeedbackdelay == 1 then 
            turnoff2 331, 2, 0
            event "i", 331, 0, 999999999   
        elseif kmaplivefeedbackdelayRand == 1 then 
            turnoff2 332, 2, 0
            event "i", 332, 0, 999999999   
        elseif kmapliveoverdub == 1 then 
            turnoff2 333, 2, 0
            event "i", 333, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapliveGrainAmpx == 1 then
    turnoff2 311, 2, 0
elseif kmapintolivex == 1 then
    turnoff2 312, 2, 0
elseif kmapsynthtolivex == 1 then
    turnoff2 313, 2, 0
elseif kmapsftolivex == 1 then
    turnoff2 314, 2, 0
elseif kmapouttolivex == 1 then
    turnoff2 315, 2, 0
elseif kmapliveratex == 1 then
    turnoff2 316, 2, 0
elseif kmapliverateRandomx == 1 then
    turnoff2 317, 2, 0
elseif kmaplivetransposex == 1 then
    turnoff2 318, 2, 0
elseif kmaplivetransposeRandomx == 1 then
    turnoff2 319, 2, 0
elseif kmaplivepanCenterx == 1 then
    turnoff2 320, 2, 0
elseif kmaplivepanRandomx == 1 then
    turnoff2 321, 2, 0
elseif kmaplivegrainSizex == 1 then
    turnoff2 322, 2, 0
elseif kmaplivegrainSizeRandomx == 1 then
    turnoff2 323, 2, 0
elseif kmaplivewindowPosx == 1 then
    turnoff2 324, 2, 0
elseif kmaplivewindowPosRandomx == 1 then
    turnoff2 325, 2, 0
elseif kmapliveloopSizex == 1 then
    turnoff2 326, 2, 0
elseif kmaplivedelayx == 1 then
    turnoff2 327, 2, 0
elseif kmaplivedelayRandomx == 1 then
    turnoff2 328, 2, 0
elseif kmaplivefeedbackx == 1 then
    turnoff2 329, 2, 0
elseif kmaplivefeedbackRandx == 1 then
    turnoff2 330, 2, 0
elseif kmaplivefeedbackdelayx == 1 then
    turnoff2 331, 2, 0
elseif kmaplivefeedbackdelayRandx == 1 then
    turnoff2 332, 2, 0
elseif kmapliveoverdubx == 1 then
    turnoff2 333, 2, 0
endif
endin

instr 311 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,2 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "liveGrainAmp"
endin

instr 312 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,2 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "intolive"
endin

instr 313 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,2 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "synthtolive"
endin

instr 314 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,2 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "sftolive"
endin

instr 315 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,2 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "outtolive"
endin

instr 316 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.25,500 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "liverate"
endin

instr 317 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "liverateRandom"
endin

instr 318 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "livetranspose"
endin

instr 319 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,12 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "livetransposeRandom"
endin

instr 320 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "livepanCenter"
endin

instr 321 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "livepanRandom"
endin

instr 322 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.005,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "livegrainSize"
endin

instr 323 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "livegrainSizeRandom"
endin

instr 324 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "livewindowPos"
endin

instr 325 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "livewindowPosRandom"
endin

instr 326 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.5,20 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "liveloopSize"
endin

instr 327 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.0001,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "livedelay"
endin

instr 328 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "livedelayRandom"
endin

instr 329 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "livefeedback"
endin

instr 330 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "livefeedbackRand"
endin

instr 331 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "livefeedbackdelay"
endin

instr 332 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "livefeedbackdelayRand"
endin

instr 333 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "liveoverdub"
endin

//#EFFECTS

instr 500   ;global FX for EQ, distortion, LP, Phaser, Flanger, etc
;input gaSynL and gaSynR, output gaFXL and gaFXR
;master effects section


aL=gaSynL+gasfL+gamicL+gasfgranL+galivegrL + gaLiveGrainOut[0]*a(chnget:k("liveGrainAmp"))  
aR=gaSynR+gasfR+gamicR+gasfgranR+galivegrR + gaLiveGrainOut[1]*a(chnget:k("liveGrainAmp"))  

aL dcblock2 aL ;need to block DC offset that results from grain summing
aR dcblock2 aR

;distortion
kdiston chnget "diston"
if kdiston==0 goto nodist
kdist chnget "distA"
kdist port kdist,.05
ad1L distort aL,kdist,26
ad1R distort aR,kdist,26
aL balance2 ad1L,aL
aR balance2 ad1R,aR

kdist2 chnget "distB"
kdist2=1-kdist2
kdist2 port kdist2,.05
ad2L powershape aL,kdist2
ad2R powershape aR,kdist2
aL balance2 ad2L,aL
aR balance2 ad2R,aR

kdist3 chnget "distC"
kdist3 port kdist3,.05
ad3L fold aL,kdist3
ad3R fold aR,kdist3
aL balance2 ad3L,aL
aR balance2 ad3R,aR

nodist:
;LP filter
kLPon chnget "LPon"
if kLPon==0 goto noLP
kLPsel chnget "LPsel"
kLPcps chnget "LPcps"
kLPcps port kLPcps,.1
kLPcfr chnget "LPcfr"
kLPcfd chnget "LPcfd"
kLPcfrand chnget "LPrand"
kLPres chnget "LPres"
kLPresr chnget "LPresr"
kLPresd chnget "LPresd"
kLPjit jitter kLPcfr*kLPcfrand,3,11
kLPcf oscili kLPcfd,kLPcfr+kLPjit,25
kLPQ oscili kLPresd,kLPresr,25
a1L,a2L,a3L,a4L mvclpf4 aL,cpsoct(kLPcf+kLPcps),kLPQ+kLPres
a1R,a2R,a3R,a4R mvclpf4 aR,cpsoct(kLPcf+kLPcps),kLPQ+kLPres
if kLPsel=1 then
alpL=a1L
alpR=a1R
elseif kLPsel=2 then
alpL=a2L
alpR=a2R
elseif kLPsel=3 then
alpL=a3L
alpR=a3R
elseif kLPsel=4 then
alpL=a4L
alpR=a4R
endif
aL balance alpL,aL
aR balance alpR,aR

noLP:
;4 Parallel Filters
kparon chnget "paron"
kfport chnget "fport"
if kparon==0 goto nopar
kparsel1 chnget "parsel1"
kparsel2 chnget "parsel2"
kparsel3 chnget "parsel3"
kparsel4 chnget "parsel4"
kparF1 chnget "parF1"
kparF2 chnget "parF2"
kparF3 chnget "parF3"
kparF4 chnget "parF4"
kparF1 portk kparF1,kfport
kparF2 portk kparF2,kfport
kparF3 portk kparF3,kfport
kparF4 portk kparF4,kfport
kparcfr1 chnget "parcfr1"
kparcfr2 chnget "parcfr2"
kparcfr3 chnget "parcfr3"
kparcfr4 chnget "parcfr4"
kparcfd1 chnget "parcfd1"
kparcfd2 chnget "parcfd2"
kparcfd3 chnget "parcfd3"
kparcfd4 chnget "parcfd4"
kparcfrnd1 chnget "parcfrnd1"
kparcfrnd2 chnget "parcfrnd2"
kparcfrnd3 chnget "parcfrnd3"
kparcfrnd4 chnget "parcfrnd4"
kparres1 chnget "parres1"
kparres2 chnget "parres2"
kparres3 chnget "parres3"
kparres4 chnget "parres4"
kparres1 portk kparres1,kfport
kparres2 portk kparres2,kfport
kparres3 portk kparres3,kfport
kparres4 portk kparres4,kfport
kparamp1 chnget "paramp1"
kparamp2 chnget "paramp2"
kparamp3 chnget "paramp3"
kparamp4 chnget "paramp4"
kparamp1 portk kparamp1,kfport
kparamp2 portk kparamp2,kfport
kparamp3 portk kparamp3,kfport
kparamp4 portk kparamp4,kfport
kparjit1 jitter kparcfr1*kparcfrnd1,2.5,8
kparjit2 jitter kparcfr2*kparcfrnd2,3.5,11
kparjit3 jitter kparcfr3*kparcfrnd3,3,10
kparjit4 jitter kparcfr4*kparcfrnd4,2.1,9
kpardev1 oscili kparcfd1,kparcfr1+kparjit1,25
kpardev2 oscili kparcfd2,kparcfr2+kparjit2,25
kpardev3 oscili kparcfd3,kparcfr3+kparjit3,25
kpardev4 oscili kparcfd4,kparcfr4+kparjit4,25
a1lpL,a1bpL,a1hpL zdf_2pole_mode aL,cpsoct(kparF1+kpardev1),kparres1
a1lpR,a1bpR,a1hpR zdf_2pole_mode aR,cpsoct(kparF1+kpardev1),kparres1
a2lpL,a2bpL,a2hpL zdf_2pole_mode aL,cpsoct(kparF2+kpardev2),kparres2
a2lpR,a2bpR,a2hpR zdf_2pole_mode aR,cpsoct(kparF2+kpardev2),kparres2
a3lpL,a3bpL,a3hpL zdf_2pole_mode aL,cpsoct(kparF3+kpardev3),kparres3
a3lpR,a3bpR,a3hpR zdf_2pole_mode aR,cpsoct(kparF3+kpardev3),kparres3
a4lpL,a4bpL,a4hpL zdf_2pole_mode aL,cpsoct(kparF4+kpardev4),kparres4
a4lpR,a4bpR,a4hpR zdf_2pole_mode aR,cpsoct(kparF4+kpardev4),kparres4
if kparsel1=1 then
apar1L=a1lpL
apar1R=a1lpR
elseif kparsel1=2 then
apar1L=a1bpL
apar1R=a1bpR
elseif kparsel1=3 then
apar1L=a1hpL
apar1R=a1hpR
elseif kparsel1=4 then
apar1L=0
apar1R=0
endif
if kparsel2=1 then
apar2L=a2lpL
apar2R=a2lpR
elseif kparsel2=2 then
apar2L=a2bpL
apar2R=a2bpR
elseif kparsel2=3 then
apar2L=a2hpL
apar2R=a2hpR
elseif kparsel2=4 then
apar2L=0
apar2R=0
endif
if kparsel3=1 then
apar3L=a3lpL
apar3R=a3lpR
elseif kparsel3=2 then
apar3L=a3bpL
apar3R=a3bpR
elseif kparsel3=3 then
apar3L=a3hpL
apar3R=a3hpR
elseif kparsel3=4 then
apar3L=0
apar3R=0
endif
if kparsel3=1 then
apar4L=a4lpL
apar4R=a4lpR
elseif kparsel4=2 then
apar4L=a4bpL
apar4R=a4bpR
elseif kparsel4=3 then
apar4L=a4hpL
apar4R=a4hpR
elseif kparsel4=4 then
apar4L=0
apar4R=0
endif
aparsumL=(apar1L*kparamp1)+(apar2L*kparamp2)+(apar3L*kparamp3)+(apar4L*kparamp4)
aparsumR=(apar1R*kparamp1)+(apar2R*kparamp2)+(apar3R*kparamp3)+(apar4R*kparamp4)
aL balance aparsumL,aL
aR balance aparsumR,aR

nopar:
;phaser
kphson chnget "phson"
if kphson==0 goto nophaser
kphscps chnget "phscps"
kphsQ chnget "phsQ"
kphsFB chnget "phsFB"
kphsdev oscil 25,kphscps,25
aLphs phaser2 aL,100+kphsdev,kphsQ,20,1,1,kphsFB
aRphs phaser2 aR,100+kphsdev,kphsQ,20,1,1,kphsFB
aL=(aL+aLphs)*.5
aR=(aR+aRphs)*.5

nophaser:
;flanger
kflon chnget "flon"
if kflon==0 goto noflanger
kflcps chnget "flcps"
kflFB chnget "flFB"
adel oscil .02,kflcps,27
aLfl flanger aL,adel*.05,kflFB,.1
aLfl clip aLfl,1,1
aRfl flanger aR,adel*.05,kflFB,.1
aRfl clip aRfl,1,1
aL=(aL+aLfl)*.5
aR=(aR+aRfl)*.5

noflanger:
;global transposer with 6 voices
kton chnget "ton"
if kton==0 goto noharmon
kharmon1 chnget "harmon1" ;on/off button
kharmon2 chnget "harmon2"
kharmon3 chnget "harmon3"
kharmon4 chnget "harmon4"
kharmon5 chnget "harmon5"
kharmon6 chnget "harmon6"
kharm1 port kharmon1,.05
kharm2 port kharmon2,.05
kharm3 port kharmon3,.05
kharm4 port kharmon4,.05
kharm5 port kharmon5,.05
kharm6 port kharmon6,.05

kTport chnget "Tport"
kT1C chnget "harmon1C"
kT1F chnget "harmon1F"
kT2C chnget "harmon2C"
kT2F chnget "harmon2F"
kT3C chnget "harmon3C"
kT3F chnget "harmon3F"
kT4C chnget "harmon4C"
kT4F chnget "harmon4F"
kT5C chnget "harmon5C"
kT5F chnget "harmon5F"
kT6C chnget "harmon6C"
kT6F chnget "harmon6F"
kT1C portk kT1C,kTport
kT1F portk kT1F,kTport
kT2C portk kT2C,kTport
kT2F portk kT2F,kTport
kT3C portk kT3C,kTport
kT3F portk kT3F,kTport
kT4C portk kT4C,kTport
kT4F portk kT4F,kTport
kT5C portk kT5C,kTport
kT5F portk kT5F,kTport
kT6C portk kT6C,kTport
kT6F portk kT6F,kTport

kshift1=kT1C+kT1F
kshift2=kT2C+kT2F
kshift3=kT3C+kT3F
kshift4=kT4C+kT4F
kshift5=kT5C+kT5F
kshift6=kT6C+kT6F
kharmmix chnget "harmmix"
ibase=cpsoct(8) ;middle C as base frequency

kratio1=cpsoct(8+(kshift1/12))/ibase ;Transposition ratio
kratio2=cpsoct(8+(kshift2/12))/ibase 
kratio3=cpsoct(8+(kshift3/12))/ibase 
kratio4=cpsoct(8+(kshift4/12))/ibase 
kratio5=cpsoct(8+(kshift5/12))/ibase 
kratio6=cpsoct(8+(kshift6/12))/ibase 

kjit1 jitter .002,.75,3.7
kjit2 jitter .001,.15,2.11
kjit3 jitter .0023,.1,1.4
kjit4 jitter .0025,.4,4.7
kjit5 jitter .0016,.6,3.8
kjit6 jitter .0019,.31,5.6

kratio1=kratio1+kjit1
kratio2=kratio2+kjit2
kratio3=kratio3+kjit3
kratio4=kratio4+kjit4
kratio5=kratio5+kjit5
kratio6=kratio6+kjit6

fftinL pvsanal aL,512,128,512,1 ;FFT analysis
fftinR pvsanal aR,512,128,512,1

fftT1L pvscale fftinL,kratio1 ;pitch scaling and resynthesis
fftT1R pvscale fftinR,kratio1
aT1L pvsynth fftT1L
aT1R pvsynth fftT1R

fftT2L pvscale fftinL,kratio2
fftT2R pvscale fftinR,kratio2
aT2L pvsynth fftT2L
aT2R pvsynth fftT2R

fftT3L pvscale fftinL,kratio3
fftT3R pvscale fftinR,kratio3
aT3L pvsynth fftT3L
aT3R pvsynth fftT3R

fftT4L pvscale fftinL,kratio4
fftT4R pvscale fftinR,kratio4
aT4L pvsynth fftT4L
aT4R pvsynth fftT4R

fftT5L pvscale fftinL,kratio5
fftT5R pvscale fftinR,kratio5
aT5L pvsynth fftT5L
aT5R pvsynth fftT5R

fftT6L pvscale fftinL,kratio6
fftT6R pvscale fftinR,kratio6
aT6L pvsynth fftT6L
aT6R pvsynth fftT6R

asumL=(aT1L*kharm1)+(aT2L*kharm2)+(aT3L*kharm3)+(aT4L*kharm4)+(aT5L*kharm5)+(aT6L*kharm6)
asumR=(aT1R*kharm1)+(aT2R*kharm2)+(aT3R*kharm3)+(aT4R*kharm4)+(aT5R*kharm5)+(aT6R*kharm6)
aL=(aL*(1-kharmmix))+(asumL*kharmmix)
aR=(aR*(1-kharmmix))+(asumR*kharmmix)

noharmon:
gaFXL=aL
gaFXR=aR

endin

;does global harmonizer with 6 voices need to be its own instrument here?

instr 502   ;global chorus
kchon chnget "chon"
kchmix chnget "chmix"
kchFB chnget "chFB"
kchdepth chnget "chdepth"
kchcps chnget "chcps"
kchrand chnget "chrand"
kchdel chnget "chdel"
if kchon==0 goto NOCHOR
achorusFBL init 0
achorusFBR init 0
afeedL=gaFXL+achorusFBL
afeedR=gaFXR+achorusFBR
kdepthrand=kchdepth*kchrand*.001
kchdel=kchdel*.001
kcpsrand=kchcps*kchrand
kchcps randomi kchcps-kcpsrand,kchcps+kcpsrand,kchcps
kchdepth randomi kchdepth-kdepthrand,kchdepth+kdepthrand,kchcps
kchdepth port kchdepth,.1
ardelL oscili kchdepth,kchcps,25
ardelR oscili kchdepth,kchcps,25,.25
ardel3 oscili kchdepth,kchcps,25,.5
ardel4 oscili kchdepth,kchcps,25,.75
ardelL=ardelL+(kchdepth*2.1+kchdel)
ardelR=ardelR+(kchdepth*2.1+kchdel)
ardel3=ardel3+(kchdepth*2.1+kchdel)
ardel4=ardel4+(kchdepth*2.1+kchdel)
amodL vdelay afeedL,ardelL,200
amodR vdelay afeedR,ardelR,200
amod3 vdelay afeedL*.33+afeedR*.66,ardel3,200
amod4 vdelay afeedR*.33+afeedL*.66,ardel4,200
achorusFBL=dcblock(((amodL*.6)+(amod4*.3)+(amod3*.15))*-kchFB)
achorusFBR=dcblock(((amodR*.6)+(amod3*.3)+(amod4*.15))*-kchFB)
gaChorL=((afeedL*.7+amodL)*kchmix)+((1-kchmix)*gaFXL)
gaChorR=((afeedR*.7+amodR)*kchmix)+((1-kchmix)*gaFXR)
goto LAST
NOCHOR:
gaChorL=gaFXL
gaChorR=gaFXR
LAST:
endin

instr 505   ;global FB delay FX
kdelon chnget "delon"
if kdelon==0 goto NODEL
aFBL init 0
aFBR init 0
kdel chnget "deltime"
kdel port kdel,.05
adel interp kdel*1000
kDelFB chnget "delFB"
aLdel vdelay gaChorL+aFBL,adel,5000
aRdel vdelay gaChorR+aFBR,adel,5000
aFBL=dcblock((aLdel*kDelFB)+gaChorL)
aFBR=dcblock((aRdel*kDelFB)+gaChorR)
gaDelL=aFBL
gaDelR=aFBR
goto LAST
NODEL:
gaDelL=gaChorL
gaDelR=gaChorR
LAST:
endin

instr 510   ;global reverb, always on
krevon chnget "revon"
if krevon==0 goto NOREV
krevmix chnget "revmix"
krevmix port krevmix,.05
krevFB chnget "revFB"
krevLP chnget "revLP"
aLrev,aRrev reverbsc gaDelL,gaDelR,krevFB,krevLP,sr,.075 ;don't need these to be global
gafinalL=(gaDelL*(1-krevmix))+(aLrev*krevmix)
gafinalR=(gaDelR*(1-krevmix))+(aRrev*krevmix)
goto FINALOUT
NOREV:
gafinalL=gaDelL
gafinalR=gaDelR
FINALOUT:
outs gafinalL,gafinalR
endin

instr 600	; record file
irecch chnget "recch"
ibit chnget "bit"
 print	p1
 if gkplay==1 then
  chnset	k(0),"record"
  turnoff
 endif
 gkFileRecorded		init	1
 itim     date
 Stim     dates     itim
 itim     date
 Stim     dates     itim
 Syear    strsub    Stim, 20, 24
 Smonth   strsub    Stim, 4, 7
 Sday     strsub    Stim, 8, 10
 iday     strtod    Sday
 Shor     strsub    Stim, 11, 13
 Smin     strsub    Stim, 14, 16
 Ssec     strsub    Stim, 17, 19
 Sfilnam  sprintf  "%s_%s_%02d_%s_%s_%s.wav", Syear, Smonth, iday, Shor,Smin, Ssec
 gSname   sprintf "Granary_%s", Sfilnam
 if gkrecord==1 then			; record
  if ibit=1 then
   imode=4
  elseif ibit=2 then
   imode=8
  elseif ibit=3 then
   imode=5
  endif
  if irecch=1 then
   fout gSname,imode,(gafinalL+gafinalR)*.7
  elseif irecch=2 then
   fout gSname,imode,gafinalL, gafinalR
  endif
 endif
 gkRecordingActiveFlag	=	1 - release()
endin

instr	601	; play file
 if gkplay==0 then
  turnoff
 endif 
   aL,aR	diskin2	gSname,1
  	outs	aL,aR
 iFileLen	filelen	gSname
 p3	=	iFileLen
 xtratim	0.1 
 krelease	release
 	chnset	1-krelease,"play"
endin

//#GLOBAL CLEAR

instr 750   ;clear global audio paths that include feedback (don't need to clear the global LFO outputs)

ksynthtolive chnget "synthtolive"
ksynthtolive port ksynthtolive,.025
ksftolive chnget "sftolive"
ksftolive port ksftolive,.02
kouttolive chnget "outtolive"
kouttolive port kouttolive,.02

gaGrainInputBus[0] = gaGrainInputBus[0]+(gaSynL*ksynthtolive) 
gaGrainInputBus[1] = gaGrainInputBus[1]+(gaSynR*ksynthtolive)
gaGrainInputBus[0] = gaGrainInputBus[0]+(ksftolive*gasfgranL) 
gaGrainInputBus[1] = gaGrainInputBus[1]+(ksftolive*gasfgranR)
gaGrainInputBus[0] = gaGrainInputBus[0]+gaFXL*kouttolive
gaGrainInputBus[1] = gaGrainInputBus[1]+gaFXR*kouttolive

gaLiveGrainOut = gaLiveGrainOut*0
clear   gaSynL,gaSynR,gaDelL,gaDelR,gaFXL,gaFXR,galiveL,galiveR,gafinalL,gafinalR,gasfgranL,gasfgranR,galivegrL,galivegrR,gagrainFBdL,gagrainFBdR
endin

</CsInstruments>

<CsScore>
;causes Csound to run for about 7000 years...
f0 z
;f1 0 2097152 10 0 ;create a 45 second (assuming 48 kHz) function table that we will use as a buffer to write left channel audio into
;f2 0 2097152 10 0 ;create a 45 second (assuming 48 kHz) function table that we will use as a buffer to write right channel audio into

f21 0 8192 -5 .35 8192 .05 ;exponential curve down) from 1-.05

f25 0 8193 10 1   ;sine for FM and AM
f26 0 8193 7 -1 3500 -1 1193 1 3500 1   ;for distort opcode waveshaping
f27 0 16385 7 0 8192 1 8193 0   ;used to control flanger delay
f28 0 8193 10 1 0 .333 0 .2 0 .144 0 .1111 ;square wave
f29 0 8193 20 3 ;triangle envelope for harmonizer
f30 0 8193 7 0 2048 1 4097 -1 2048 0 ;triangle for LFO
f31 0 8193 7 1 4096 1 0 -1 4097 -1 ;square for LFO
f32 0 8193 7 0 8193 1 ;ramp up for LFO
f33 0 8193 7 0 8193 -1 ;ramp down for LFO
f34 0 8193 10 1 1 1 1 1 1 1 1 1 1 .9 .7 .5 .3 .1 ;pulse for LFO
f35 0 8193 10 1 -.5 .33333 -.25 .2 -.1666 .14286 -.125 .11111 -.1 ;saw

f101 0 8193 10 1 0 .333 0 .2 0 .144 0 .1111 0 .090909 0 .076923 0 .0666666 0 .0588235 0 .052632 ;square wave
f102 0 8193 10 1 -.5 .33333 -.25 .2 -.1666 .14286 -.125 .11111 -.1 .090909 -.83333 .076923 -.071428 .0666666 -.0625 .0588235 -.055555 .052632 ;saw
f103 0 8193 7 0 2048 1 4097 -1 2048 0 ;triangle
f104 0 8193 10 1 1 1 1 1 1 1 1 1 1 1 1 .9 .8 .7 .6 .5 .4 .3 .2 .1 ;pulse
f105 0 8193 10 1 ;sine
f106 0 8193 10 0 1 ;harmonic 1
f107 0 8193 10 0 0 1 ;harmonic 2
f108 0 8193 10 0 0 0 1 ;harmonic 3
f109 0 8193 10 0 0 0 0 1 ;harmonic 4
f110 0 8193 10 0 0 0 0 0 1 ;harmonic 5
f111 0 8193 10 0 0 0 0 0 0 1 ;harmonic 6
f112 0 8193 10 0 0 0 0 0 0 0 1 ;harmonic 7
f113 0 8193 10 0 0 0 0 0 0 0 0 1 ;harmonic 8
f114 0 8193 10 0 0 0 0 0 0 0 0 0 1 ;harmonic 9
f115 0 8193 10 0 0 0 0 0 0 0 0 0 0 1 ;harmonic 10
f116 0 8193 10 0 0 0 0 0 0 0 0 0 0 0 1 ;harmonic 11
f117 0 8193 10 0 0 0 0 0 0 0 0 0 0 0 0 1 ;harmonic 12
f118 0 8193 10 0 0 0 0 0 0 0 0 0 0 0 0 0 1 ;harmonic 13
f119 0 8193 10 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 ;harmonic 14
f120 0 8193 10 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 ;harmonic 15
;piano (low res)
f121 0 8193 10 1 .11 .333 .07 .055 .055 .003 .025 .002 .003 0 .003 .004 .001 .0005
;guitar
f122 0 8193 10 1 .675 1.265 .125 .12 .115 .005 .01 .185 .055 .015 .008 .009 .01 .003 .002 .002
;cello
f123 0 8193 10 0.022943 0.412962 0.548431 0.578468 0.092241 0.116378 0.052974 0.029585 0.093977 0.119660 0.064074 0.051807 0.015094 0.094184 0.015488 0.006640 0.007091 0.011557 0.043467 0.023330 0.018118 0.026921 0.010285 0.007653 0.015306 0.023175
;violin
f124 0 8193 10 0.403041 0.281156 0.259204 0.392900 0.236559 0.108769 0.117288 0.063588 0.039483 0.018245 0.012717 0.020183 0.008506 0.017915 0.008925 0.008575 0.006947 0.008142 0.005487 0.005970 0.004402 0.003161 0.002361 0.001942
;bass tbn
f125 0 8193 10 0.102601 0.100887 0.167098 0.516781 0.330986 0.422868 0.412850 0.397849 0.628756 0.686835 0.929709 0.845577 0.935266 0.508059 0.792158 0.281350 0.378308 0.568489 0.346813 0.566233 0.413541 0.405762 0.359363 0.216505
;F horn
f126 0 8193 10 10 0.150333 0.205756 0.869097 0.723941 0.707935 0.116871 0.238125 0.330962 0.443031 0.325212 0.131256 0.267361 0.273576 0.146568 0.209758 0.158564 0.179271 0.084668 0.112177 0.118845 0.124993 0.096945 0.128906 0.125534 0.125534
;trumpet
f127 0 8193 10 .569 .543 .633 .7 .67 .675 .555 .41 .46 .305 .31 .365 .315 .25 .21 .24 .225 .175 .155 .185 .155 .16 .245
;contra bassoon
f128 0 8193 10 0.076357 0.137793 0.174617 0.207802 0.302523 0.705801 0.162577 0.073808 0.224559 0.050465 0.066110 0.181682 0.062409 0.052317 0.037698 0.029936 0.042341 0.053436 0.135414 0.059248 0.025689 0.033567 0.051201 0.029910 0.028697 0.052991
;bassoon
f129 0 8193 10 0.147763 0.340255 0.879202 0.404023 0.259274 0.130887 0.095096 0.039056 0.091976 0.009828 0.004879 0.013408 0.016090 0.015931 0.012402 0.003430 0.006421 0.004323 0.002018 0.001465 0.003012 0.001397 0.002446 0.002683 0.002425 0.004828
;oboe
f130 0 8193 10 0.297865 0.916220 0.218345 0.030903 0.016039 0.045984 0.003571 0.006255 0.007310 0.003701 0.001306 0.001355 0.000361 0.001108 0.001552 0.000991 0.000588 0.000780 0.000678 0.001103 0.000615 0.000264 0.000310 0.000464 0.000464
;saxophone
f131 0 8193 10 .14 .23 .142 .18 .2 .07 .015 .05 .062 .09 .043 .01 .025 .037 .056 .06 .057 .049 .062 .048 .03 .023 .02 .011 .017
;contrabass clarinet
f132 0 8193 10 0.227476 0.006718 0.707706 0.018101 0.539432 0.018848 0.590242 0.029143 0.512926 0.035712 0.324304 0.035306 0.035964 0.050992 0.096916 0.025035 0.098203 0.072427 0.068155 0.060324 0.042818 0.074538 0.049430 0.100999 0.052956 0.109337
; bass clarinet
f133 0 8193 10 0.819856 0.006052 0.508263 0.007439 0.271031 0.012967 0.059374 0.017922 0.016997 0.004014 0.027132 0.014921 0.020230 0.012123 0.021066 0.004875 0.016894 0.004428 0.004157 0.007603 0.004211 0.011103 0.005054 0.007329 0.004043 0.002169
;clarinet
f134 0 8193 10 0.753504 0.011446 0.501720 0.055791 0.241768 0.037889 0.027203 0.062793 0.102494 0.030506 0.042453 0.050202 0.031077 0.027208 0.020897 0.022205 0.012154 0.008160 0.004886 0.005076 0.003805 0.001322 0.001149 0.001450 0.001450
;bass flute
f135 0 8193 10 0.801592 0.068816 0.032303 0.012614 0.002660 0.014692 0.002493 0.006175 0.001826 0.001416 0.002607 0.001063 0.001542 0.001053 0.001293 0.001226 0.000781 0.001142 0.000975 0.000922 0.000693 0.000570 0.000538 0.000429 0.000587
;flute
f136 0 8193 10 0.925667 0.059839 0.214284 0.013980 0.026778 0.008733 0.019436 0.002640 0.004217 0.002126 0.003513 0.002455 0.001336 0.001508 0.001589 0.002155 0.002549 0.001951 0.001614 0.001076 0.001253 0.001138 0.001073 0.000990 0.000990
;piccolo
f137 0 8193 10 0.730803 0.323120 0.277720 0.044844 0.009400 0.022785 0.004602 0.005762 0.006400 0.002483 0.001490 0.002354 0.004728 0.002669 0.003175 0.001177 0.000761 0.000509 0.000449 0.000703 0.001078 0.002471 0.003905 0.004114 0.004114

f201 0 8192 19 .5 .5 270 .5  ;guassian rise for attack/decay lookup
f202 0 8192 7 0 8192 1 ;linear rise
f203 0 8192 5 0.00001 8192 1 ;exponential rise
f204 0 8192 8 0 1000 0 6192 1 1000 1 ;cubis spline rise




i1 0 999999     ;live audio input and sf management
;i2 and i3 play and load soundfiles for input
         ;i4 0 999999    ;mixes mic/line and soundfile playback
i4 0 999999 ;grainstream on/off
;i5 is the synth grain generator triggered by the keyboard
;i6-9 are the synth grain generators, each with a different audio source
;i10 is scrubbing-controlled granulation
;i11 is targeted granulation and keyboard controlled granulation
i12 0 999999 ;always on to control soundfile and live audio granulation
;i15 is each soundfile granulation grain
;i20 is live audio on, also mixes in synth or sf granulation into the live feed
;i21 generates live feed grain data
;i22 0 999999 ;draws live feed into gentable widgets
;25 granulates (a single grain) of the live audio
;;;i30 0 999999 ;live audio plus live grain mixer NOT SURE IF MIXER OPCODES ARE WORKING CORRECTLY
i55 0 999999    ;PW rslider GUI control
i60 0 999999 ;vocal formant preset control
i61 0 999999 ;Transposer preset control
i100 0 999999 ;MIDI controller mapping
i101 0 999999 ;MIDI controller instruments
i103 0 999999
i105 0 999999
i110 0 999999
i120 0 999999
i130 0 999999
i140 0 999999
i150 0 999999
i160 0 999999
i170 0 999999
i200 0 999999
i210 0 999999
i220 0 999999
i230 0 999999
i240 0 999999
i250 0 999999
i260 0 999999
i280 0 999999
i290 0 999999
i300 0 999999
i310 0 999999
i500 0 999999       ;global FX
i502 0 999999
i505 0 999999       ;global delay
i510 0 999999       ;global reverb
;i600-601 are the record and play functions
i750 0 999999       ;global audio clear
i "liveGrainInit" 0 0 
i "liveGrainStateCheck" 0.25 99999
i "liveGrainWriteTab" 0.25 99999
i "envCheck" 0.25 99999
;i "liveGrainMappers" 0.25 99999
</CsScore>
</CsoundSynthesizer>
